/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/




#include <pspkernel.h>
#include <pspiofilemgr.h>
#include <pspmodulemgr.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspusb.h>
#include <pspusbstor.h>
#include <pspthreadman.h>
#include <pspctrl.h>
#include <pspsdk.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_ttf.h>
//#include <SDL/SDL_rotozoom.h>
//#include <SDL/SDL_gfxPrimitives.h>
//#include "sge_surface.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string>
#include <vector>
#include <fstream>
#include <algorithm>
using namespace std;

class Dir
{
	public:
		string name;
		int isDir;
	
	private:
};

string lkeys[4][9] = { { " ", "`", "1", "2", "3", "4", "5", "6", " " },
          { " ", "     ", "     ", "q", "w", "e", "r", "t", " " },
          { " ", "cl", "cl", "a", "s", "d", "f", "g", " " },
          { " ", "ls", "ls", "z", "x", "c", "v", "b", " " } };
          
string rkeys[4][9] = { { " ", "7", "8", "9", "0", "-", "=", "bs", "bs" },
          { " ", "y", "u", "i", "o", "p", "[", "]", "\\" },
          { " ", "h", "j", "k", "l", ";", "'", "en", "en" },
          { " ", "n", "m", ",", ".", "/", "rs", "rs", " " } };
		  
string keys[4][17] = { { " ", "`", "1", "2", "3", "4", "5", "6", " ", "7", "8", "9", "0", "-", "=", "bs", "bs" },
          { " ", "     ", "     ", "q", "w", "e", "r", "t", " ", "y", "u", "i", "o", "p", "[", "]", "\\" },
          { " ", "cl", "cl", "a", "s", "d", "f", "g", " ", "h", "j", "k", "l", ";", "'", "en", "en" },
          { " ", "ls", "ls", "z", "x", "c", "v", "b", " ", "n", "m", ",", ".", "/", "rs", "rs", " " } };
          
string lskeys[4][9] = { { " ", "~", "!", "@", "#", "$", "%", "^", " " },
           { " ", "     ", "     ", "Q", "W", "E", "R", "T", " " },
           { " ", "cl", "cl", "A", "S", "D", "F", "G", " " },
           { " ", "ls", "ls", "Z", "X", "C", "V", "B", " " } };
          
string rskeys[4][9] = { { " ", "&", "*", "(", ")", "_", "+", "bs", "bs" },
           { " ", "Y", "U", "I", "O", "P", "{", "}", "|" },
           { " ", "H", "J", "K", "L", ":", "\"", "en", "en" },
           { " ", "N", "M", "<", ">", "?", "rs", "rs", " " } };
		   
string skeys[4][17] = { { " ", "~", "!", "@", "#", "$", "%", "^", " ", "&", "*", "(", ")", "_", "+", "bs", "bs" },
           { " ", "     ", "     ", "Q", "W", "E", "R", "T", " ", "Y", "U", "I", "O", "P", "{", "}", "|" },
           { " ", "cl", "cl", "A", "S", "D", "F", "G", " ", "H", "J", "K", "L", ":", "\"", "en", "en" },
           { " ", "ls", "ls", "Z", "X", "C", "V", "B", " ", "N", "M", "<", ">", "?", "rs", "rs", " " } };		   
             
string lckeys[4][9] = { { " ", "`", "1", "2", "3", "4", "5", "6", " " },
           { " ", "     ", "     ", "Q", "W", "E", "R", "T", " " },
           { " ", "cl", "cl", "A", "S", "D", "F", "G", " " },
           { " ", "ls", "ls", "Z", "X", "C", "V", "B", " " } };
          
string rckeys[4][9] = { { " ", "7", "8", "9", "0", "-", "=", "bs", "bs" },
           { " ", "Y", "U", "I", "O", "P", "[", "]", "\\" },
           { " ", "H", "J", "K", "L", ";", "'", "en", "en" },
           { " ", "N", "M", ",", ".", "/", "rs", "rs", " " } } ;
		   
string ckeys[4][17] = { { " ", "`", "1", "2", "3", "4", "5", "6", " ", "7", "8", "9", "0", "-", "=", "bs", "bs" },
           { " ", "     ", "     ", "Q", "W", "E", "R", "T", " ", "Y", "U", "I", "O", "P", "[", "]", "\\" },
           { " ", "cl", "cl", "A", "S", "D", "F", "G", " ", "H", "J", "K", "L", ";", "'", "en", "en" },
           { " ", "ls", "ls", "Z", "X", "C", "V", "B", " ", "N", "M", ",", ".", "/", "rs", "rs", " " } };

string lcskeys[4][9] = { { " ", "~", "!", "@", "#", "$", "%", "^", " " },
            { " ", "     ", "     ", "q", "w", "e", "r", "t", " " },
            { " ", "cl", "cl", "a", "s", "d", "f", "g", " " },
            { " ", "ls", "ls", "z", "x", "c", "v", "b", " " } };
          
string rcskeys[4][9] = { { " ", "&", "*", "(", ")", "_", "+", "bs", "bs" },
            { " ", "y", "u", "i", "o", "p", "{", "}", "|" },
            { " ", "h", "j", "k", "l", ":", "\"", "en", "en" },
            { " ", "n", "m", "<", ">", "?", "rs", "rs", " " } };
			
string cskeys[4][17] = { { " ", "~", "!", "@", "#", "$", "%", "^", " ", "&", "*", "(", ")", "_", "+", "bs", "bs" },
            { " ", "     ", "     ", "q", "w", "e", "r", "t", " ", "y", "u", "i", "o", "p", "{", "}", "|" },
            { " ", "cl", "cl", "a", "s", "d", "f", "g", " ", "h", "j", "k", "l", ":", "\"", "en", "en" },
            { " ", "ls", "ls", "z", "x", "c", "v", "b", " ", "n", "m", "<", ">", "?", "rs", "rs", " " } };

SDL_Surface *img_text, *img_background, *img_arrows, *img_ascii, *img_buttons, *img_check, *img_doc, *img_dot, *img_folder, *img_space, *screen;
SDL_Surface *img_rckeys, *img_lckeys, *img_lcskeys, *img_rcskeys, *img_lkeys, *img_rkeys, *img_lskeys, *img_rskeys;
SDL_Surface *img_textbackground, *img_zoom, *tmp, *img_view;
SDL_Color sdlwhite = { 0xFF, 0xFF, 0xFF, 0 };
SDL_Color sdlblack = { 0x00, 0x00, 0x00, 0 };
SDL_Color sdlgrey = { 0xC8, 0xC8, 0xC8, 0 };
SDL_Color sdlred = { 0xFF, 0x00, 0x00, 0 };
SDL_Color sdlgreen = { 0x00, 0xFF, 0x00, 0 };
SDL_Color sdlblue = { 0x00, 0x00, 0xFF, 0 };
SDL_Color forecol, fgcol, bgcol;
Uint32 backcol, white, black, grey, lightgrey, darkgrey, red, green, blue;
SDL_Rect dest;
TTF_Font *font, *drawfont, *drawfont10, *drawfont12, *drawfont14, *drawfont16, *systemfont;
int ndCol = 7, ndLine = 12, nFontsize = 12, minlines = 14, maxlines = 21; 
/* Globals used for sge_Update/sge_Lock */
Uint8 _sge_update=1;
Uint8 _sge_lock=1;
string openfile = "Untitled.doc";
vector <string> text, settings;
vector <string> wraptext;

SceIoDirent g_dir;
vector <Dir> dir;
vector <string> dirlist;
int nDir;
bool bUpdate = false;
bool caps = false, shift = false;
int blink = 0, cursor = 0, scrollx = 0, scrolly = 0, ly = 0, lx = 0, ry = 0, rx = 0, line = 0, insertline = 0, list;
int wait, nMaxchar = 66, nWW;
int nKeyset = 2, nCol = 7, nLine = 12;
SceCtrlData pad;
SceCtrlLatch latch;
u32 state;


string readKey(void);
void loadUsbDrivers(void);
bool is_image(string file);
void textWrap1(void);
void textWrap2(void);
void readKeyboard(void);
void loadSettings(void);
void saveSettings(void);
void listDirectory(string path);
void update(void);
int load_gfx(void);
void drawKeyboard(void);
void drawText(TTF_Font* font,SDL_Surface* surface, int x, int y, string text, SDL_Color color);
void drawTextShadowed(TTF_Font* font,SDL_Surface* surface, int x, int y, string text, SDL_Color color);
void drawFillRect(SDL_Surface* surface, int x0,int y0, int w, int h, Uint32 color);
void drawHline(SDL_Surface* surface, int x0,int y0, int w, Uint32 color);
void drawVline(SDL_Surface* surface, int x0,int y0, int h, Uint32 color);
void drawRect(SDL_Surface* surface, int x0, int y0, int w, int h, Uint32 color);
void blit(SDL_Surface * Dest, Sint16 DestX, Sint16 DestY, SDL_Surface * Src);
void drawDropmenu(SDL_Surface* surface, int x0, int y0, int nChar, int nList);
void drawFrame(SDL_Surface* surface, int x0, int y0, int w, int h);
void drawMenuFrame(SDL_Surface* surface);
void set_colors(SDL_PixelFormat* format);
void setBounds(int fontsize);
void sge_ClearSurface(SDL_Surface *Surface, Uint32 color);
int sge_Blit(SDL_Surface *Src, SDL_Surface *Dest, Sint16 SrcX, Sint16 SrcY, Sint16 DestX, Sint16 DestY, Sint16 W, Sint16 H);
extern "C" int SDL_main( int argc, char *argv[] );

int main(int argc, char *argv[])
{
	int count, retval;
	string readline;
	string debugtext;
	bool padrelease, found;
	int loc, bm;
	char sizestring[50];
	
	int endtext;	
	
	int mark1[2] = {-1,-1}, mark2[2] = {-1,-1}, temp[2] = {0,0};

	int colcursor = 1;
	int imscrollx = 0, imscrolly = 0, imindex = 0;
	int findfirst=0, findline=0, findlast=0;
	
	vector <string> copytext;
	string findtext, findtextscroll, renamefile, renamefilescroll, oldfile, oldfilescroll;
	string replacetext, replacetextscroll, deletefile, deletefilescroll, gotoline, gotolinescroll;
	int  nText, num, testline;
	bool wordwrap = false, wordwrap1 = false, wordwrap2 = false;
	bool bTabbed = false;
	string textscroll, temptext;
	string readfile, readkey;
	int mode = 1, menumode = 0, lastmode = 1, menucursor = 1, menupos = 10;
	bool usb = false;
		
	vector <int> bookmark;
	int current = 0;
	ofstream writefile;
	ofstream settingsfile;
	string savefile;
	char path[256];
	getcwd(path, 256);
	
	int dircursor = 0, dirselect = 0, dirscroll = 0, nDir = 0, dirmaxlines = 10, nMaxinput = 36;
	string savename, dirname, openfilescroll, currentdirscroll;
	string currentdir = "ms0:", upcurrentdir = "";

	ifstream file;
		
	text.clear();
	text.push_back("");
	nText = text.size();

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	
	loadUsbDrivers();
	

	/* Initialize the SDL library */
	if ( SDL_Init(SDL_INIT_TIMER|SDL_INIT_VIDEO) < 0 ) {
		fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
		return(255);
	}
	
	/* Initialize the TTF library */
	if ( TTF_Init() < 0 ) {
		fprintf(stderr, "Couldn't initialize TTF: %s\n",SDL_GetError());
		return(2);
	}
	atexit(TTF_Quit);
	font = TTF_OpenFont("/image/lucon.ttf", 12);
	drawfont = TTF_OpenFont("/image/lucon.ttf", 12);
	drawfont10 = TTF_OpenFont("/image/lucon.ttf", 10);
	drawfont12 = TTF_OpenFont("/image/lucon.ttf", 12);
	drawfont14 = TTF_OpenFont("/image/lucon.ttf", 14);
	drawfont16 = TTF_OpenFont("/image/lucon.ttf", 16);
	systemfont = TTF_OpenFont("/image/lucon.ttf",10);
	atexit(SDL_Quit);
	
	screen = SDL_SetVideoMode(480, 272, 32, SDL_FULLSCREEN | SDL_HWSURFACE | SDL_DOUBLEBUF);	
	if(load_gfx()){
		fprintf(stderr, "Error: %s\n", SDL_GetError());
		exit(1);	
	}
	set_colors(screen->format);
	
	SDL_FillRect(img_textbackground, NULL, white);
	sge_ClearSurface(screen, 0xFFFFFFFF);

	//listDirectory(currentdir);
	loadSettings();
	bUpdate = true;
	padrelease = true;
	while(1){
		//SDL_FillRect(screen, NULL, black);
		if (padrelease) sceCtrlReadBufferPositive(&pad, 1); 
		sceCtrlReadLatch(&latch);
		
		blink++;
		if (blink == 30) blink = 0;
		wait = 1;
		nText = text.size();
		
		if (padrelease) {
			if (pad.Buttons & PSP_CTRL_SELECT) {
				if (mode < 4) lastmode = mode;
				if (mode == 1) mode = 2;
				else mode = 1;
				if (nText > minlines && (scrolly + nText < minlines)) scrolly = minlines - nText;
				mark1[0] = -1;
				mark1[1] = -1;
				mark2[0] = -1;
				mark2[1] = -1;
				update();
				wait = 200;
				padrelease = false;
			}
			
			if (pad.Buttons & PSP_CTRL_START) {
				if (mode == 7) {
					lastmode = mode;
					mode = 6;
				}
				else if (mode == 6) {
					lastmode = mode;
					listDirectory(currentdir);
					nDir = dir.size();
					dircursor = 0;
					dirselect = 0;
					dirscroll = 0;
					mode = 7;
				}
				else if (menumode > 0) menumode = 0;
				else {
					lastmode = mode;
					menucursor = 1;
					if (mode == 1) menumode = 1;
					else if (mode == 2) menumode = 2;
					else if (mode == 3) menumode = 3;
					else menumode = 1;
				}
				update();
				wait = 200;
				padrelease = false;
			}
		}		
	
		if (menumode == 0) {
			if (mode == 1) {
				readKeyboard();
				readkey = readKey();
				if (readkey != "") {
					if (readkey == "bs") {
						if (cursor == text[line].size()+1) 
							text[line] = text[line].substr( 0, text[line].size() - 1);
						else if (cursor > 0)
							text[line] = text[line].substr( 0, cursor - 1) + text[line].substr(cursor, text[line].size() - 1);
							
						cursor--;
						if (cursor < 0 && line > 0) {
							line--;
							cursor = text[line].size();
							if (text[line+1].size() > 0) text[line] = text[line] + text[line+1];
							text.erase(text.begin()+line+1);
							nText = text.size();
						}
						if (cursor < 0) cursor = 0;
						if (line + scrolly < 0) scrolly = scrolly + 1;
						if (cursor + scrollx == 0) scrollx = scrollx + 4;
						if (scrollx > 0) scrollx = 0;
					}
					else if (readkey == "en") {
							if (line == nText - 1) {
								text.resize(nText+1,"");
								if (cursor < text[line].size()) {
									text[line+1] = text[line].substr(cursor);
									text[line] = text[line].substr(0,cursor);
								}
								line++;
								cursor = 0;
							}
							if (line < nText - 1) {
								text.resize(nText+1);
								nText++;
								count = nText-1;
								while (count > line) {
									text[count] = text[count - 1];
									count--;
								}
								if (cursor < text[line].size()) {
									text[line+1] = text[line].substr(cursor);
									text[line] = text[line].substr(0,cursor);
								}
								else text[line+1] = "";
								line++;
								cursor = 0;
								scrollx = 0;
							}
							if (line + scrolly > minlines - 1) scrolly--;
					}				
					else {
						text[line].insert(cursor,readkey);

						shift = false;
						cursor++;
						if (readkey == "     ") cursor = cursor + 4;
						
						if (cursor > (nMaxchar - 2) - scrollx) scrollx = scrollx - 4;
					}
					if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar)) scrollx = 0 - cursor;
					if ((line + scrolly < 0) || (line + scrolly > minlines)) scrolly = 0 - line;
					if ((nText > minlines) && (scrolly < minlines - nText)) scrolly = minlines - nText;
		
					update();
					blink = 0;
					wait = 100;
					if (shift) wait = 60;				
				}
			
			}
			
	if (mode == 2) {   
		if (pad.Buttons & PSP_CTRL_UP) {
			line--;
			if (line < 0) line = 0;
			if (cursor > text[line].size()) cursor = text[line].size();
			if ((line + scrolly) < 0) scrolly++;
			if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar-1)) scrollx = 0 - cursor;
			if ((line + scrolly < 0) || (line + scrolly > minlines-1)) scrolly = 0 - line;
			if ((nText > minlines) && (scrolly < minlines - nText)) scrolly = minlines - nText;
			update();
			blink = 0;
			wait = 40;			
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			line++;
			if (line == nText) line = nText-1;
			if (cursor > text[line].size()) cursor = text[line].size();
			if (line + scrolly > minlines - 1 && line < nText) scrolly = scrolly--;
			if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar)) scrollx = 0 - cursor;
			if ((line + scrolly < 0) || (line + scrolly > minlines)) scrolly = 0 - line;
			if ((nText > minlines) && (scrolly < minlines - nText)) scrolly = minlines - nText;
			update();
			blink = 0;
			wait = 40;			
		}
		
		if (pad.Buttons & PSP_CTRL_LEFT) {
			cursor--;
			if (cursor < 0 && line == 0 && scrollx >= 0) cursor = 0;
			if (cursor < 0 && line > 0 && scrollx >= 0) {
				line--;
				cursor = text[line].size();
			}
			if ((cursor + scrollx) < 0) {
				scrollx = scrollx + 4;
				if (scrollx > 0) {
					scrollx = 0;
				}
			}
			if (cursor > (nMaxchar - 2 - scrollx)) scrollx = scrollx - 4;
			if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar - 1)) scrollx = 0 - cursor;
			if ((line + scrolly < 0) || (line + scrolly > minlines - 1)) scrolly = 0 - line;
			if ((nText > minlines) && (scrolly < minlines - nText)) scrolly = minlines - nText;				
			update();
			blink = 0;
			wait = 40;			
		}
		
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			cursor++;
			if (cursor > text[line].size() && line < nText - 1) {
				cursor = 0;
				line++;
			}
			if (cursor > text[line].size() && line == nText - 1) cursor = text[line].size();
			if ((cursor + scrollx) < 0) scrollx = scrollx + 4;
			
			if (cursor > (nMaxchar - 2 - scrollx)) scrollx = scrollx - 4;
			if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar - 1)) scrollx = 0 - cursor;
			if ((line + scrolly < 0) || (line + scrolly > minlines - 1)) scrolly = 0 - line;
			if ((nText > minlines) && (scrolly < minlines - nText)) scrolly = minlines - nText;				
			update();
			blink = 0;
			wait = 40;	
		}

		if (pad.Buttons & PSP_CTRL_RTRIGGER && nText > minlines) {
			line = line + minlines - 1;
			scrolly = scrolly - minlines + 1;
			if (line + minlines > nText) {
				if (line >= nText) line = nText-1;
				scrolly = minlines - nText;
			}
			if (cursor > text[line].size()) {
				cursor = text[line].size();
			}
			update();
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_LTRIGGER) {
			line = line - minlines + 1;
			scrolly = scrolly + minlines - 1;
			if ((line - minlines - 1) < 0) {
				if (line < 0) line = 0;
				scrolly = 0;
			}
			if (cursor > text[line].size()) {
				cursor = text[line].size();
			}
			update();
			wait = 80;
		}

		if (padrelease) {

			if (pad.Buttons & PSP_CTRL_TRIANGLE) {
				if (mark2[0] != -1) {
					mark1[0] = -1;
					mark1[1] = -1;
					mark2[0] = -1;
					mark2[1] = -1;
				}
				else if (mark1[0] == -1) {
					mark1[0] = cursor;
					mark1[1] = line;
				}
				else if (mark1[0] != -1) {
					mark2[0] = cursor;
					mark2[1] = line;
					if ((mark2[0] < mark1[0] && mark2[1] <= mark1[1]) || (mark2[1]  < mark1[1])) {
						temp[0] = mark1[0];
						temp[1] = mark1[1];
						mark1[0] = mark2[0];
						mark1[1] = mark2[1];
						mark2[0] = temp[0];
						mark2[1] = temp[1];
					}					 			
				}	
				if (mark1[0] == mark2[0] && mark1[1] == mark2[1]) {
					mark1[0] = -1;
					mark1[1] = -1;
					mark2[0] = -1;
					mark2[1] = -1;
				}
				update();
				wait = 200;
				padrelease = false;
			}

	
			if (pad.Buttons & PSP_CTRL_SQUARE) {
				findfirst = text[line].find_first_not_of(" ");
				if (findfirst == string::npos) {
					findfirst = 0;
				}
				if (cursor != findfirst && findfirst != 0) {				
					cursor = findfirst;
					if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar - 1)) scrollx = nMaxchar - cursor - 4;	
				}
				else {
					cursor = 0;
					scrollx = 0;
				}
				
				if (line < 0 - scrolly || line > minlines - scrolly - 1) scrolly = 0 - line;
				
				update();
				wait = 200;
				padrelease = false;
			}
	
			if (pad.Buttons & PSP_CTRL_CIRCLE) {
				cursor = text[line].size();
				if (cursor + scrollx < 0 || cursor + scrollx > nMaxchar - 1) scrollx = nMaxchar - cursor - 4;
				if (line < 0 - scrolly || line > minlines - scrolly - 1) scrolly = 0 - line;				
				update();
				padrelease = false;
			}
		}				
	}
	
	if (mode == 3) {
		if (wordwrap) {
			num = nWW;
			//temptext = wraptext;
		}
		else {
			num = nText;
			//temptext = text;
		}

		if (pad.Buttons & PSP_CTRL_DOWN) {
			if ((num + scrolly) > minlines && mode < 3) {
				scrolly--;
				wait = 10;
			}
			if ((num + scrolly) > maxlines && mode == 3) {
				scrolly--;
				wait = 10;
			}
			update();
		}
		if (pad.Buttons & PSP_CTRL_UP) {
			if (scrolly != 0) {
				scrolly++;
				wait = 10;
			}
			update();
		}

		if (!wordwrap) {
			if (pad.Buttons & PSP_CTRL_RIGHT) {
				scrollx--;
				wait = 10;
				update();
			}
			if (pad.Buttons & PSP_CTRL_LEFT) {
				if (scrollx != 0) {
					scrollx++;
					wait = 10;
				}
				update();			
			}
		}
				
		if (pad.Buttons & PSP_CTRL_RTRIGGER && num > maxlines) {
			scrolly = scrolly - maxlines + 1;
			if (scrolly + num < maxlines) {
				scrolly = maxlines - num;
			}
			update();
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_LTRIGGER) {
			scrolly = scrolly + maxlines - 1;
			if (scrolly > 0) scrolly = 0;
	
			update();
			wait = 80;
		}
	}
	
	if (mode < 4) {
		if (mode != 3 || (mode == 3 && !wordwrap)) {
			if (pad.Lx == 0) {
				if (scrollx != 0) {
					scrollx++;
					wait = 10;
				}
				update();			
			}		
			if (pad.Lx == 255) {
				scrollx--;
				wait = 10;
				update();
			}
		}

		
		if (pad.Ly == 0) {
			if (scrolly != 0) {
				scrolly++;
				wait = 10;
			}
			update();
		}
		if (pad.Ly == 255) {
			if (wordwrap) num = nWW;
			else num = nText;
			if ((num + scrolly) > minlines and mode < 3) {
				scrolly--;
				wait = 10;
			}
			if ((num + scrolly) > maxlines and mode == 3) {
				scrolly--;
				wait = 10;
			}
			update();
		}
	}

	if (mode == 4) {

		if (pad.Lx == 0) {
			if (img_view->w > 480) {
				if (imscrollx >= 0) imscrollx = 0;
				else imscrollx+=4;
			}
		}
		if (pad.Lx == 255) {
			if (img_view->w > 480) {
				if (img_view->w + imscrollx <= 480) imscrollx = 480-img_view->w;
				else imscrollx-=4;
			}
		}
		if (pad.Ly == 0) {
			if (img_view->h > 272) {
				if (imscrolly >= 0) imscrolly = 0;
				else imscrolly+=4;
			}
		}
		if (pad.Ly == 255) {
			if (img_view->h > 272) {
				if (img_view->h + imscrolly <= 272) imscrolly = 272-img_view->h;
				else imscrolly-=4;
			}
		}		
		
		if (pad.Buttons & PSP_CTRL_LTRIGGER && padrelease) {
			imindex--;
			if (imindex < 0) imindex = dirlist.size() - 1;

			readfile = currentdir + "/" + dirlist[imindex];

			tmp=IMG_Load(readfile.c_str());
			if(!tmp){img_view = screen;}
			else img_view=SDL_DisplayFormat(tmp);
			SDL_FreeSurface(tmp);
			imscrollx = 0;
			imscrolly = 0;
			if (img_view->w < 480) imscrollx = 240-img_view->w/2;
			if (img_view->h < 272) imscrolly = 136-img_view->h/2;
			wait = 250;
			padrelease = false;
		}
		if (pad.Buttons & PSP_CTRL_RTRIGGER && padrelease) {
			imindex++;
			if (imindex == dirlist.size()) imindex = 0;
			
			readfile = currentdir + "/" + dirlist[imindex];

			tmp=IMG_Load(readfile.c_str());
			if(!tmp){update(); img_view = screen;}
			else img_view=SDL_DisplayFormat(tmp);
			SDL_FreeSurface(tmp);
			
			imscrollx = 0;
			imscrolly = 0;
			if (img_view->w < 480) imscrollx = 240-img_view->w/2;
			if (img_view->h < 272) imscrolly = 136-img_view->h/2;
			wait = 250;
			padrelease = false;
		}
	}

	if (mode == 5 || mode == 7) {
	
		//upcurrentdir = updir(currentdir)
		
		if (pad.Buttons & PSP_CTRL_UP) {
			if ((dirselect + dirscroll == 0) && dirselect > 0) dirscroll++;
			dirselect--;
			if (dirselect < 0) dirselect = 0;
			dircursor--;
			if (dircursor < 0) dircursor = 0;
	
			wait = 100;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			if ((dirselect + dirscroll == dirmaxlines-1) && dirselect < nDir-1) dirscroll--;
			dirselect++;
			if (dirselect == nDir) dirselect = nDir-1;
			dircursor++;
			if (dircursor == dirmaxlines) dircursor = dirmaxlines-1;
			
			if (dircursor == nDir) dircursor = nDir-1;
	
			wait = 100;
		}
	}

	if (mode == 5) {	
		if (padrelease) {
			if (pad.Buttons & PSP_CTRL_CROSS) {
				if (dir[dirselect].isDir) {
					findlast = currentdir.find_last_of("/");
					if (findlast != string::npos) upcurrentdir = currentdir.substr(0,findlast);
					else upcurrentdir = "ms0:";
					
					if (dir[dirselect].name == "..") currentdir = upcurrentdir;
					else if (dir[dirselect].name != ".") currentdir = currentdir + "/" + dir[dirselect].name;
					
					listDirectory(currentdir);
					nDir = dir.size();
					dircursor = 0;
					dirselect = 0;
					dirscroll = 0;
				}
				else {		
					readfile = currentdir + "/" + dir[dirselect].name;
					
					if (is_image(dir[dirselect].name)) {
						mode = 4;
						imindex = 0;
						while (dir[dirselect].name != dirlist[imindex]) imindex++;
						//openfile = "Untitled.doc";
						imscrollx = 0;
						imscrolly = 0;
						tmp=IMG_Load(readfile.c_str());
						if(!tmp){img_view = screen;}
						else img_view=SDL_DisplayFormat(tmp);
						if (img_view->w < 480) imscrollx = 240-img_view->w/2;
						if (img_view->h < 272) imscrolly = 136-img_view->h/2;
						SDL_FreeSurface(tmp);
					}
					else {
						text.clear();
						nText = text.size();
						count = 1;
						cursor = 0;
						scrollx = 0;
						scrolly = 0;
						ly = 0;
						lx = 0;
						ry = 0;
						rx = 0;
						bookmark.clear();
						current = 0;
						mark1[0] = -1;
						mark1[1] = -1;
						mark2[0] = -1;
						mark2[1] = -1;
						line = 0;
			
						readfile = currentdir + "/" + dir[dirselect].name;
						openfile = dir[dirselect].name;
						file.open(readfile.c_str());
						while (getline(file,readline,'\n')) {
							
							loc = readline.find((char) 13,0);
							if (loc != string::npos) readline.resize(readline.size()-1);
							loc = readline.find((char) 9,0);
							while (loc != string::npos) {
								readline.replace(loc,1,"     ");
								loc = readline.find((char) 9,0);
							}
							text.push_back(readline);
						}
						file.close();
						if (text.size() < 1) text.push_back("");
	
						mode = 3;
						update();
						nText = text.size();
						if (wordwrap) {
							if (wordwrap2) { textWrap2(); }
							else { textWrap1(); }
						}
					}
				}
				wait = 200;
				padrelease = false;
			}
			
		}
	}	

	if (mode == 6) {
		readKeyboard();
		readkey = readKey();
		if (readkey != "") {
			if (readkey == "bs") {
				if (openfile.size() > 0) openfile.resize(openfile.size()-1);
			}
			else if (readkey == "en") {
				if (openfile.size() > 0) {
					/*
					if (state & PSP_USB_ACTIVATED) {
						retval = sceUsbDeactivate();
						usb = false;
					}
					*/
					savefile = currentdir + "/" + openfile;
					writefile.open(savefile.c_str());
					for (count = 0; count < text.size(); count++) {
						readline = text[count];
						loc = readline.find("     ",0);
						while (loc != string::npos) {							
							readline.replace(loc,5,"\t",1);
							loc = readline.find("     ",0);
						}					
						writefile << readline << endl;
					}
					writefile.close();
					mode = 1;
					wait = 100;
					update();
				}
			}
			else if (openfile.size() < 256) {
					openfile = openfile + readkey;
					shift = false;
				}
			
			blink = 0;
			wait = 100;
		}
	}	

	if (mode == 7) {
		if (padrelease) {
			if (pad.Buttons & PSP_CTRL_CROSS) {
				if (dir[dirselect].isDir) {
					findlast = currentdir.find_last_of("/");
					if (findlast != string::npos) upcurrentdir = currentdir.substr(0,findlast);
					else upcurrentdir = "ms0:";
					
					if (dir[dirselect].name == "..") currentdir = upcurrentdir;
					else if (dir[dirselect].name != ".") currentdir = currentdir + "/" + dir[dirselect].name;
					
					listDirectory(currentdir);
					nDir = dir.size();
					dircursor = 0;
					dirselect = 0;
					dirscroll = 0;
				}
				else {
					openfile = dir[dirselect].name;
					mode = 6;
				}
				padrelease = false;
			}		
		}
	}
	
	if (mode == 8) {
		readKeyboard();
		readkey = readKey();
		if (readkey != "") {
			if (readkey == "bs") {
				if (findtext.size() > 0) findtext.resize(findtext.size()-1);
			}
			else if (readkey == "en") {
				if (findtext.size() > 0) {
					findline = line;
					findfirst = text[findline].find(findtext,cursor);
					findline++;
					while (findfirst == string::npos && findline < nText) {
						findfirst = text[findline].find(findtext,0);
						findline++;
					}
					
					if (findfirst != string::npos) {
					
						cursor = findfirst+findtext.size();
						line = findline-1;
						mark1[0] = findfirst;
						mark1[1] = line;
						mark2[0] = cursor;
						mark2[1] = line;

						if ((cursor + scrollx < 0) && (cursor + scrollx > nMaxchar)) scrollx = nMaxchar - cursor - 4;
						if ((line < 0 - scrolly) || (line > minlines - scrolly)) scrolly = 0 - line;						
					}
					update();
					mode = 2;
					wait = 100;
				}
			}
			else  {
				findtext = findtext + readkey;
				shift = false;
			}
			blink = 0;
			wait = 100;
		}
	}
	
	if (mode == 9) {
		readKeyboard();
		readkey = readKey();
		if (readkey != "") {
			if (readkey == "     ") bTabbed = !bTabbed;
			else if (readkey == "bs") {
				if (!bTabbed) {
					if (findtext.size() > 0) findtext.resize(findtext.size()-1);
				}
				else if (replacetext.size() > 0) replacetext.resize(replacetext.size()-1);
			}
			else if (readkey == "en") {
				if (findtext.size() > 0  && replacetext.size() > 0) {
					findline = line;
					findfirst = text[findline].find(findtext,cursor);
					findline++;
					while (findfirst == string::npos && findline < nText) {
						findfirst = text[findline].find(findtext);
						findline++;
					}

					if (findfirst != string::npos) {
						text[findline-1].replace( findfirst, findtext.size(), replacetext.c_str(), replacetext.size());
						cursor = findfirst + replacetext.size();
						line = findline-1;
						mark1[0] = findfirst;
						mark1[1] = line;
						mark2[0] = findfirst + replacetext.size();
						mark2[1] = line;
						
						if ((cursor + scrollx < 0) && (cursor + scrollx > nMaxchar)) scrollx = nMaxchar - cursor - 4;
						if ((line < 0 - scrolly) || (line > minlines - scrolly)) scrolly = 0 - line;
					}
					update();
					mode = 2;
					wait = 100;
				}	
			}
			else  {
				if (!bTabbed) findtext = findtext + readkey;
				else replacetext = replacetext + readkey;
				shift = false;
			}
			blink = 0;
			wait = 100;
		}
	}
		
	if (mode == 10) {
		readKeyboard();
		readkey = readKey();
		if (readkey != "") {
			if (readkey == "bs") {
				if (gotoline.size() > 0) gotoline = gotoline.substr(0, gotoline.size() - 1);
			}
			else if (readkey == "en") {
				testline = atoi(gotoline.c_str());
				if (testline > 0) {
					line = testline - 1;
					if (line < 0) line = 0;
					if (line > nText - 1) line = nText - 1;
					cursor = 0;
					scrollx = 0;
					if (nText > minlines) {
						scrolly = 0 - line;
						if (scrolly < minlines - nText) scrolly = minlines - nText;	
					}
					update();						
					mode = 2;
					wait = 10;					
				}
			}
			else if (readkey.size() == 1) {
				if (isdigit((int) *readkey.c_str())) gotoline = gotoline + readkey;
			}
			
			blink = 0;
			wait = 100;
		}
	}
	if (mode == 11) {
		if (pad.Buttons & PSP_CTRL_UP) {
			if (colcursor == 1) colcursor = 3;
			else colcursor--;
			
			wait = 100;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			if (colcursor == 3) colcursor = 1;
			else colcursor++;
			
			wait = 100;
		}
		
		if (pad.Buttons & PSP_CTRL_LEFT) {
			if (colcursor == 1) {
				if (bgcol.r != 0) bgcol.r--;
			}
			if (colcursor == 2) {
				if (bgcol.g != 0) bgcol.g--;
			}
			if (colcursor == 3) {
				if (bgcol.b != 0) bgcol.b--;
			}
			wait = 1;
		}
		
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			if (colcursor == 1) {
				if (bgcol.r != 255) bgcol.r++;
			}
			if (colcursor == 2) {
				if (bgcol.g != 255) bgcol.g++;
			}
			if (colcursor == 3) {
				if (bgcol.b != 255) bgcol.b++;
			}
			wait = 1;
		}

		if (pad.Buttons & PSP_CTRL_CIRCLE) {
			backcol = SDL_MapRGB(screen->format,bgcol.r,bgcol.g,bgcol.b);
			mode = 3;
			update();			
			wait = 200;
			saveSettings();
		}
	}

	if (mode == 12) {
		if (pad.Buttons & PSP_CTRL_UP) {
			if (colcursor == 1) colcursor = 3;
			else colcursor--;
			
			wait = 100;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			if (colcursor == 3) colcursor = 1;
			else colcursor++;
			
			wait = 100;
		}
		
		if (pad.Buttons & PSP_CTRL_LEFT) {
			if (colcursor == 1) {
				if (fgcol.r != 0) fgcol.r--;
			}
			if (colcursor == 2) {
				if (fgcol.g != 0) fgcol.g--;
			}
			if (colcursor == 3) {
				if (fgcol.b != 0) fgcol.b--;
			}
			wait = 1;
		}
		
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			if (colcursor == 1) {
				if (fgcol.r != 255) fgcol.r++;
			}
			if (colcursor == 2) {
				if (fgcol.g != 255) fgcol.g++;
			}
			if (colcursor == 3) {
				if (fgcol.b != 255) fgcol.b++;
			}
			wait = 1;
		}
		
		if (pad.Buttons & PSP_CTRL_CIRCLE) {
			forecol = fgcol;
			mode = 3;
			update();			
			wait = 200;
			saveSettings();
		}
	}	
	} // end menumode == 0;
		
	if (menumode == 1) {
		if (pad.Buttons & PSP_CTRL_UP) {
			menucursor--;
			if (menucursor < 1) {
				menucursor = 5;
			}
			wait = 100;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			menucursor++;
			if (menucursor > 5) {
				menucursor = 1;
			}
			wait = 100;
		}
		
		if (padrelease) {
			if (pad.Buttons & PSP_CTRL_RIGHT) {
				menumode = 2;
				lastmode = mode;
				if (mode < 4) {
					mode = 2;
				}
				menucursor = 1;
				wait = 100;
				padrelease = false;
			}
		
			if (pad.Buttons & PSP_CTRL_LEFT) {
				menumode = 3;
				menucursor = 1;
				wait = 100;
				padrelease = false;
			}
		}
		
		if (pad.Buttons & PSP_CTRL_CROSS) {
	
			if (menucursor == 1) {
				text.clear();
				text.push_back("");
				openfile = "Untitled.doc";
				mode = 1;
				cursor = 0;
				scrollx = 0;
				scrolly = 0;
				ly = 0;
				lx = 0;
				ry = 0;
				rx = 0;
				line = 0;
				mark1[0] = -1;
				mark1[1] = -1;
				mark2[0] = -1;
				mark2[1] = -1;
				current = 0;
				bookmark.clear();
				nText = text.size();
				update();
			}
			if (menucursor == 2) {
				mode = 5;
				listDirectory(currentdir);
				nDir = dir.size();
				dircursor = 0;
				dirselect = 0;
				dirscroll = 0;
				padrelease = false;
			}
			if (menucursor == 3) {
				mode = 6;
			}
			if (menucursor == 4) {
				state = sceUsbGetState();
				usb = !usb;
				
				if (state & PSP_USB_ACTIVATED) retval = sceUsbDeactivate();
				else retval = sceUsbActivate(0x1c8);
				
				mode = lastmode;
			}
			if (menucursor == 5) {
				if (state & PSP_USB_ACTIVATED) retval = sceUsbDeactivate();
				break;
			}
			menumode = 0;
			lastmode = 1;
			wait = 100;
		}
	}
	
	if (menumode == 2) {
		if (padrelease) {
			if (pad.Buttons & PSP_CTRL_RIGHT) {
				menumode = 3;
				mode = lastmode;
				menucursor = 1;
				wait = 100;
				padrelease = false;
			}
			
			if (pad.Buttons & PSP_CTRL_LEFT) {
				menumode = 1;
				mode = lastmode;
				menucursor = 1;
				wait = 100;
				padrelease = false;
			}
		}		
		
		if (pad.Buttons & PSP_CTRL_UP) {
			if (menucursor == 1) menucursor = 9;
			else menucursor--;
			wait = 100;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			if (menucursor == 9)  menucursor = 1;
			else menucursor++;
			wait = 100;
		}	

		if (pad.Buttons & PSP_CTRL_CROSS) {

			if (menucursor == 1 && mark2[0] != -1) {
				copytext.clear();
				if (mark2[1] == mark1[1]) copytext.push_back(text[mark1[1]].substr(mark1[0], mark2[0] - mark1[0]));
				
				if (mark2[1] > mark1[1]) {
					for (count = mark1[1]; count <= mark2[1]; count++) {
						if (count == mark2[1]) copytext.push_back(text[count].substr(0, mark2[0]));
						else if (count == mark1[1]) copytext.insert(copytext.begin(),text[count].substr(mark1[0]));							
						else copytext.push_back(text[count]);
					}
				}
				
				if (mark2[1] == mark1[1]) {
					text[mark1[1]].erase(mark1[0],mark2[0]-mark1[0]);
				}
				
				if (mark2[1] > mark1[1]) {	
					text[mark1[1]].erase(mark1[0]);
					
					text[mark2[1]] = text[mark2[1]].substr(mark2[0]);
					
					text[mark1[1]] = text[mark1[1]]+text[mark2[1]];
					text.erase(text.begin()+mark2[1]);
					if (mark2[1] - mark1[1] > 1) {
						for (count = mark1[1]+1; count<=mark2[1]-1;count++) text.erase(text.begin()+count);
					}
				}
				cursor = mark1[0];
				line = mark1[1];

				if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar)) scrollx = 0 - cursor;
				if ((line + scrolly < 0) || (line + scrolly > minlines)) scrolly = 0 - line;
				if ((nText > minlines) && (scrolly < minlines - nText)) scrolly = minlines - nText;
					
				nText = text.size();
				mark1[0] = -1;
				mark1[1] = -1;
				mark2[0] = -1;
				mark2[1] = -1;
				update();
			
			}

			if (menucursor == 2 && mark2[1] != -1) {
				copytext.clear();
				if (mark2[1] == mark1[1]) copytext.push_back(text[mark1[1]].substr(mark1[0], mark2[0] - mark1[0]));
				
				if (mark2[1] > mark1[1]) {
					for (count = mark1[1]; count <= mark2[1]; count++) {
						if (count == mark2[1]) copytext.push_back(text[count].substr(0, mark2[0]));
						else if (count == mark1[1]) copytext.insert(copytext.begin(),text[count].substr(mark1[0]));							
						else copytext.push_back(text[count]);
					}
				}				
			}			
			
			if (menucursor == 3 && !copytext.empty() && copytext[0].size() > 0) {
				if (mark2[1] != -1 ) {
					if (mark2[1] == mark1[1]) {
						text[mark1[1]].erase(mark1[0],mark2[0]-mark1[0]);
					}
					
					if (mark2[1] > mark1[1]) {	
						text[mark1[1]].erase(mark1[0]);
						
						text[mark2[1]] = text[mark2[1]].substr(mark2[0]);
						
						text[mark1[1]] = text[mark1[1]]+text[mark2[1]];
						text.erase(text.begin()+mark2[1]);
						if (mark2[1] - mark1[1] > 1) {
							for (count = mark1[1]+1; count<=mark2[1]-1;count++) text.erase(text.begin()+count);
						}
					}
					cursor = mark1[0];
					line = mark1[1];
				}
				
				if (copytext.size() == 1) text[line].insert(cursor,copytext[0]);
				
				if (copytext.size() > 1 ) {
					if (cursor == 0) {
						temptext = copytext[copytext.size()-1] + text[line];
						text[line] = copytext[0];
						text.insert(text.begin()+line+1, temptext);
					}
					else if (cursor == text[line].size()) {
						text[line] = text[line]+copytext[0];
						text.insert(text.begin()+line+1, copytext[copytext.size()-1]);
					}
					else {
						temptext = copytext[copytext.size()-1]+text[line].substr(cursor);
						text[line] = text[line].substr(0,cursor)+copytext[0];
						text.insert(text.begin()+line+1, temptext);							
					}
					if (copytext.size() > 2) {
						insertline = line+1;
						for (count = 1; count <= copytext.size() - 2; count++) {
							text.insert(text.begin()+insertline,copytext[count]);
							insertline++;
						}
					}
				}
	

				if (copytext.size() == 1) {
					if (cursor == 0) {		
						cursor = copytext[0].size();
					}
					else {
						cursor = cursor + copytext[0].size();
					}
				}
				else {
					cursor = copytext[copytext.size()-1].size();
				}
				line = line + copytext.size()-1;
				
				if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar)) scrollx = 0 - cursor;
				if ((line + scrolly < 0) || (line + scrolly > minlines)) scrolly = 0 - line;
				if ((nText > minlines) && (scrolly < minlines - nText)) scrolly = minlines - nText;
					
				nText = text.size();
				mark1[0] = -1;
				mark1[1] = -1;
				mark2[0] = -1;
				mark2[1] = -1;
				update();			
			}
			
			if (menucursor == 4 && mark2[0] != -1) {
				if (mark2[1] == mark1[1]) {
					text[mark1[1]].erase(mark1[0],mark2[0]-mark1[0]);
				}
				
				if (mark2[1] > mark1[1]) {	
					text[mark1[1]].erase(mark1[0]);
					
					text[mark2[1]] = text[mark2[1]].substr(mark2[0]);
					
					text[mark1[1]] = text[mark1[1]]+text[mark2[1]];
					text.erase(text.begin()+mark2[1]);
					if (mark2[1] - mark1[1] > 1) {
						for (count = mark1[1]+1; count<=mark2[1]-1;count++) text.erase(text.begin()+count);
					}
				}
				cursor = mark1[0];
				line = mark1[1];

				if ((cursor + scrollx < 0) || (cursor + scrollx > nMaxchar)) scrollx = 0 - cursor;
				if ((line + scrolly < 0) || (line + scrolly > minlines)) scrolly = 0 - line;
				if ((nText > minlines) && (scrolly < minlines - nText)) scrolly = minlines - nText;
				
				nText = text.size();
				mark1[0] = -1;
				mark1[1] = -1;
				mark2[0] = -1;
				mark2[1] = -1;
				update();						
			}
			
		
			if (menucursor == 5) mode = 8;

			if (menucursor == 6) mode = 9;
			
			if (menucursor == 7) mode = 10;
			
			if (menucursor == 8) {
				found = false;
				for (count = 0; count < bookmark.size(); count++) {
					if (line == bookmark[count]) {
						bookmark.erase(bookmark.begin()+line);
						found = true;
					}
				}
				if (!found) {
					bookmark.push_back(line);
					sort(bookmark.begin(),bookmark.end());
				}
			}
			
			if (menucursor == 9) {
				count = 0;
				found = false;
				if (current == bookmark[bookmark.size()-1]) current = -1;
				while (count < bookmark.size() && !found) {
					if (bookmark[count] > current) {
						current = bookmark[count];
						line = current;
						if (line >= nText) line = nText - 1;
						cursor = 0;
						scrollx = 0;
						if (nText > minlines) {
							scrolly = 0 - line;
							update();
							if (scrolly < minlines - nText) {
								scrolly = minlines - nText;
								update();
							}
						}	
						found = true;
					}
					count++;
				}
			}
			menumode = 0;
		}
	
	}
	
		if (menumode == 3) {
			if (padrelease) {
				if (pad.Buttons & PSP_CTRL_RIGHT) {
					menumode = 1;
					menucursor = 1;
					wait = 100;
					padrelease = false;
				}
				
				if (pad.Buttons & PSP_CTRL_LEFT) {
					lastmode = mode;
					if (mode < 4) {
						mode = 2;
					}
					menumode = 2;
					menucursor = 1;
					wait = 100;
					padrelease = false;
				}
			}
	
			
			if (pad.Buttons & PSP_CTRL_UP) {
				if (menucursor == 1) menucursor = 8;
				else menucursor--;
				wait = 100;
			}
			
			if (pad.Buttons & PSP_CTRL_DOWN) {
				if (menucursor == 8) menucursor = 1;
				else menucursor++;
				wait = 100;
			}
			
			if (pad.Buttons & PSP_CTRL_CROSS) {
				if (menucursor == 1) {
					mode = 3;
					if (wordwrap) {
						if (wordwrap1) {
							textWrap1();
						}
						if (wordwrap2) {
							textWrap2();
						}
					}
					mark1[0] = -1;
					mark1[1] = -1;
					mark2[0] = -1;
					mark2[1] = -1;
					update();
				}
				if (menucursor == 2) {
					if (nKeyset == 1) nKeyset = 2;
					else nKeyset = 1;
					lx = 0; 
					ly = 0; 
					rx = 0; 
					ry = 0;
					update();
					mode = 1;
					wait = 200;
					padrelease = false;
					saveSettings();
				}
				if (menucursor == 3) {
					wordwrap1 = !wordwrap1;
					if (wordwrap1) {
						wordwrap = true;
						textWrap1();
					}
					else wordwrap = false;
					wordwrap2 = false;
					update();
					mode = lastmode;
					if (mode == 3) {
						scrollx = 0;
						scrolly = 0;
					}
				}
				if (menucursor == 4) {
					wordwrap2 = !wordwrap2;
					if (wordwrap2) {
						textWrap2();
						wordwrap = true;
					}
					else wordwrap = false;
					wordwrap1 = false;
					update();
					mode = lastmode;
					if (mode == 3) {
						scrollx = 0;
						scrolly = 0;
					}				
				}
				if (menucursor == 5) {
					if (nFontsize != 10) {
						nFontsize -= 2;
						setBounds(nFontsize);
						if (wordwrap) {
							if (wordwrap2) { textWrap2(); }
							else { textWrap1(); }
						}
						saveSettings();
					}
					update();			
				}
				if (menucursor == 6) {
					if (nFontsize != 16) {
						nFontsize += 2;
						setBounds(nFontsize);
						if (wordwrap) {
							if (wordwrap2) { textWrap2(); }
							else { textWrap1(); }
						}
						saveSettings();
					}
					update();			
				}
				if (menucursor == 7) {
					colcursor = 1;
					SDL_GetRGB(backcol, screen->format, &(bgcol.r), &(bgcol.g), &(bgcol.b));
					lastmode = mode;
					mode = 11;
					padrelease = false;
				}
				if (menucursor == 8) {
					colcursor = 1;
					fgcol = forecol;
					lastmode = mode;
					mode = 12;
					padrelease = false;
				}
				menumode = 0;
			}
		}
	
	if (mode == 2 && bUpdate) {
		if (mark2[1] > -1) {
			if (mark2[1] == mark1[1]) {
				bm = 9+mark1[1]*ndLine + scrolly*ndLine;
				if (bm >= 9 && bm <= 170) drawFillRect(img_textbackground,4+mark1[0]*ndCol + scrollx*ndCol, 9+mark1[1]*ndLine + scrolly*ndLine, (mark2[0] - mark1[0])*ndCol+2, ndLine, lightgrey);
			}
			if (mark2[1] > mark1[1]) {
				for (count = mark1[1];count <= mark2[1]; count++) {
					if (count == mark2[1]) {
						bm = 9+mark2[1]*ndLine + scrolly*ndLine;
						if (bm >= 9 && bm <= 170) drawFillRect(img_textbackground,4 + scrollx*ndCol, 9+mark2[1]*ndLine + scrolly*ndLine, (mark2[0])*ndCol+2, ndLine, lightgrey);
					}
					else if (count == mark1[1]) {
						bm = 9+mark1[1]*ndLine + scrolly*ndLine;
						if (bm >= 9 && bm <= 170) drawFillRect(img_textbackground,4+mark1[0]*ndCol + scrollx*ndCol, 9+mark1[1]*ndLine + scrolly*ndLine, (text[count].size() - mark1[0])*ndCol+2, ndLine, lightgrey);
					}
					else {
						bm = 9+count*ndLine + scrolly*ndLine;
						if (bm >= 9 && bm <= 170) drawFillRect(img_textbackground,4 + scrollx*ndCol, 9+count*ndLine + scrolly*ndLine, (text[count].size())*ndCol+2, ndLine, lightgrey);
					}
				}
			}
		}	
	}
		
		if (mode < 3) {
			list = 180;
			for (count = 0 - scrolly; count < minlines - scrolly; count++) {
				if (count < nText) {
					if (scrollx < 0) {
						endtext = nMaxchar;
						if (text.at(count).size() < endtext) endtext = text[count].size() + scrollx;
						if (text.at(count).size() > -1-scrollx) textscroll = text.at(count).substr(0 - scrollx, endtext);
						else textscroll = " ";
						if (bUpdate) drawText(drawfont,img_textbackground, 5, 10 + count * ndLine + scrolly*ndLine, textscroll, forecol);
					}
					else {
						endtext =  nMaxchar;
						if (text.at(count).size() < endtext) endtext = text[count].size();
						textscroll = text.at(count).substr(0, endtext);
						if (bUpdate) drawText(drawfont,img_textbackground, 5, 10 + count * ndLine + scrolly*ndLine, textscroll, forecol);
					}
				}
			}
		}	

		if (mode == 3) {
			list = 260;
			if (wordwrap) {
				for (count = 0 - scrolly; count < maxlines - scrolly; count++) {
					if (count < nWW) {
						if (bUpdate) drawText(drawfont,img_textbackground, 5, 10 + count * ndLine + scrolly*ndLine, wraptext[count], forecol);					
					}
				}
			}
			else {
				for (count = 0 - scrolly; count < maxlines - scrolly; count++) {
					if (count < nText) {
						if (scrollx < 0) {
							endtext = nMaxchar;
							if (text.at(count).size() < endtext) endtext = text[count].size() + scrollx;
							if (text.at(count).size() > -1-scrollx) textscroll = text.at(count).substr(0 - scrollx, endtext);
							else textscroll = " ";
							if (bUpdate) drawText(drawfont,img_textbackground, 5, 10 + count * ndLine + scrolly*ndLine, textscroll, forecol);
						}
						else {
							endtext =  nMaxchar;
							if (text.at(count).size() < endtext) endtext = text[count].size();
							textscroll = text.at(count).substr(0, endtext);
							if (bUpdate) drawText(drawfont,img_textbackground, 5, 10 + count * ndLine + scrolly*ndLine, textscroll, forecol);
						}
					}
				}
			}
		}		
	

		
		if (mode == 1) {
			sge_Blit(img_textbackground, screen, 0,0,0,0,480,272);
			sge_Blit(img_background, screen, 0,188, 0, 188, 480, 84);
	
			drawKeyboard();
			drawFrame(screen,0,0,480,189);
			for (count = 0; count< bookmark.size(); count++) {
				bm = ndLine*bookmark[count] + ndLine*scrolly;
				if (bm >= 0 and bm <= 160) blit(screen,0,bm+12,img_dot);
			}
			//drawText(font,screen,10, 180, "Ln "+line+":"+n+"  Col "+ cursor, sdlblue)		;
			sprintf(sizestring, "Ln %d:%d  Col %d",line+1,nText,cursor+1);
			drawText(systemfont,screen,11, 181,sizestring,sdlwhite);
			drawText(systemfont,screen,10, 180,sizestring,sdlblue);
		}
		
	if (mode == 2) {
		sge_Blit(img_textbackground, screen, 0,0,0,0,480,272);
		sge_Blit(img_background,screen, 0,188, 0, 188, 480, 84);
		blit(screen,70,210, img_arrows);
		blit(screen,240,190, img_buttons);

		drawFrame(screen,0,0,480,189);
		for (count = 0; count< bookmark.size(); count++) {
			bm = ndLine*bookmark[count] + ndLine*scrolly;
			if (bm >= 0 and bm <= 160) blit(screen,0,bm+12,img_dot);
		}

		/*
		screen:print(10, 180, "Ln "..line..":"..n.."  Col "..cursor, blue)
		--screen:print(10, 180, "Ln "..line..":"..n.."  Col "..cursor.."/"..scrollx.."/"..scrolly, blue)
		*/
		//debugtext = "Sel1 "+ mark1[1] +":"+mark1[2]+"  Sel2 "+mark2[1]+":"+mark2[2];
		sprintf(sizestring, "Ln %d:%d  Col %d",line+1,nText,cursor+1);
		drawText(systemfont,screen,11, 181,sizestring,sdlwhite);		
		drawText(systemfont,screen,10, 180,sizestring,sdlblue);		
		sprintf(sizestring, "Sel1 %d:%d  Sel2 %d:%d",mark1[0]+1,mark1[1]+1,mark2[0]+1,mark2[1]+1);
		debugtext = sizestring;
		drawText(systemfont,screen,471-debugtext.size()*7, 181,debugtext,sdlwhite);
		drawText(systemfont,screen,470-debugtext.size()*7, 180,debugtext,sdlblue);
		
	}
		
		if (mode == 3) {
			sge_Blit(img_textbackground, screen,0,0,0,0,480,272);
			drawFrame(screen,0,0,480,272);
			for (count = 0; count< bookmark.size(); count++) {
				bm = ndLine*bookmark[count] + ndLine*scrolly;
				if (bm >= 0 and bm <= 240) blit(screen,0,bm+12,img_dot);
			}
			sprintf(sizestring, "Ln %d:%d  Col %d",line+1,nText,cursor+1);
			drawText(systemfont,screen,11, 263,sizestring,sdlwhite);
			drawText(systemfont,screen,10, 262,sizestring,sdlblue);
		}
		
	if (mode < 4) {
		drawText(systemfont,screen,240-openfile.size()*6/2-1,-1, openfile,sdlwhite);
		drawText(systemfont,screen,240-openfile.size()*6/2,0, openfile,sdlblack);
		if ((10 + line*ndLine + scrolly*ndLine) > 0 && (line + scrolly) < minlines && (9 + cursor*ndCol + scrollx*ndCol) >= 6 && blink < 15) {
			drawVline(screen,9+ cursor * ndCol + scrollx*ndCol - 4, 12+line*ndLine + scrolly*ndLine - 2, ndLine, darkgrey);
		}
	}

	if (mode == 4) {
		if (img_view->w < 480 || img_view->h < 272) SDL_FillRect(screen,NULL,black);
		blit(screen, imscrollx, imscrolly,img_view);
	}
		
	if (mode == 5 || mode == 7) {
		blit(screen,0,0, img_background);
		drawMenuFrame(screen);

		//drawFillRect(screen,28,28,424,132,white);
		
		drawFillRect(screen,28,28,424,10,grey);
		drawHline(screen,28,37,424,darkgrey);
		
		if (currentdir.size() > 59) dirname = currentdir.substr(0,59);
		else dirname = currentdir;
		drawText(font,screen,35,27, dirname, sdlblack);
		drawText(font,screen,226,17,"Open", sdlblack);
		for (count = 0; count < nDir; count++) {
			if (dir[count].name.size() > 56) savename = dir[count].name.substr(0,56);
			else savename = dir[count].name;
			if (dirselect == count) drawFillRect(screen,34,40+dircursor*nLine - 1, 15+savename.size() * nCol, nLine, grey);
			if ((dirscroll*nLine + count*nLine) < 120 && (dirscroll*nLine + count*nLine) >= 0) {
				if (dir[count].isDir) {
					blit(screen,35,40+dirscroll*nLine+count*nLine,img_folder);
					drawText(font,screen,48,40+dirscroll*nLine+count*nLine, savename, sdlblue);
				}
				else {
					blit(screen,35,40+dirscroll*nLine+count*nLine,img_doc);
					drawText(font,screen,48,40+dirscroll*nLine+count*nLine, savename, sdlblack);
				}
			}
		}
		wait = 60;
	}
	
	if (mode == 6) {
		blit(screen,0,0, img_background);

		drawKeyboard();
		drawMenuFrame(screen);
	
		//drawFillRect(screen,28,28,424,132,white);
		
		drawFillRect(screen,176,46,260,16,white);
		drawRect(screen,176,46,260,16,darkgrey);
		drawFillRect(screen,176,66,260,16,grey);
		drawRect(screen,176,66,260,16,darkgrey);
		
		drawText(font,screen,40, 50, "Name:            ",sdlblack);
		drawText(font,screen,40, 70, "Save in folder:  ",sdlblack);
		if (openfile.size() > nMaxinput) {
			openfilescroll = openfile.substr(openfile.size()-nMaxinput);
			if (blink < 15) drawVline(screen,178+32*8, 48,nLine, blue);
		}
		else {
			openfilescroll = openfile;
			if (blink < 15) drawVline(screen,181+openfile.size()*nCol, 48, nLine, blue);
		}
		drawText(font,screen,180,50, openfilescroll.c_str(), sdlblack);
		if (currentdir.size() > nMaxinput) currentdirscroll = currentdir.substr(0,nMaxinput);
		else currentdirscroll = currentdir;
		drawText(font,screen,180,70, currentdirscroll.c_str(), sdlblack);

		drawText(font,screen,40,100, "Press Start to change folder or select a file name", sdlblue);
		drawText(font,screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,screen,40,140, "Press Enter to save", sdlblue);

		drawText(font,screen,216,17,"Save As", sdlblack);
	}
	
	if (mode == 8) {
		blit(screen,0,0, img_background);

		drawKeyboard();
		drawMenuFrame(screen);
	
		//drawFillRect(screen,28,28,424,132,white);
		
		drawFillRect(screen,176,46,260,16,white);
		drawRect(screen,176,46,260,16,darkgrey);

		drawText(font,screen, 40, 50, "Search String:            ",sdlblack);
		if (findtext.size() > nMaxinput) {
			findtextscroll = findtext.substr(findtext.size()-nMaxinput);
			if (blink < 15) drawVline(screen,176+32*8, 48, nLine, blue);
		}
		else {
			findtextscroll = findtext;
			if (blink < 15) drawVline(screen,180+findtext.size()*nCol, 48, nLine, blue);
		}
		drawText(font,screen,180,50, findtextscroll.c_str(), sdlblack);
		drawText(font,screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,screen,40,140, "Press Enter to search", sdlblue);
		drawText(font,screen,208,17,"Find Text", sdlblack);
	}

	if (mode == 9) {
		blit(screen,0,0, img_background);

		drawKeyboard();
		drawMenuFrame(screen);
	
		//drawFillRect(screen,28,28,424,132,white);
		
		if (!bTabbed) {
			drawFillRect(screen,176,46,260,16,white);
			drawRect(screen,176,46,260,16,darkgrey);
		}
		else {
			drawFillRect(screen,176,46,260,16,grey);
			drawRect(screen,176,46,260,16,darkgrey);
		}
		
		if (bTabbed) {		
			drawFillRect(screen,176,66,260,16,white);
			drawRect(screen,176,66,260,16,darkgrey);
		}
		else {
			drawFillRect(screen,176,66,260,16,grey);
			drawRect(screen,176,66,260,16,darkgrey);
		}
		drawText(font,screen,40, 50, "Search String:",sdlblack);
		drawText(font,screen,40, 70, "Replace with:",sdlblack);
		if (findtext.size() > nMaxinput) {
			findtextscroll = findtext.substr(findtext.size()-nMaxinput);
			if (blink < 15 && !bTabbed) {
				drawVline(screen,176+32*8, 48, nLine, blue);
			}
		}
		else {
			findtextscroll = findtext;
			if (blink < 15 && !bTabbed) {
				drawVline(screen,180+findtext.size()*nCol, 48, nLine, blue);
			}
		}
		if (replacetext.size() > nMaxinput) {
			replacetextscroll = replacetext.substr(replacetext.size()-nMaxinput);
			if (blink < 15 && bTabbed) {
				drawVline(screen,176+32*8, 68, nLine, blue);
			}
		}
		else {
			replacetextscroll = replacetext;
			if (blink < 15 && bTabbed) {
				drawVline(screen,180+replacetext.size()*nCol, 68, nLine, blue);
			}
		}	
		drawText(font,screen,180,50, findtextscroll, sdlblack);
		drawText(font,screen,180,70, replacetextscroll, sdlblack);
		if (!bTabbed) drawText(font,screen,40,100, "Press Tab to input replacement text", sdlblue);
		else drawText(font,screen,40,100, "Press Tab to input search string", sdlblue);
		drawText(font,screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,screen,40,140, "Press Enter to replace", sdlblue);
		drawText(font,screen,198,17,"Replace Text", sdlblack);
	}
	
	if (mode == 10) {
		blit(screen,0,0, img_background);

		drawKeyboard();
		drawMenuFrame(screen);
	
		//drawFillRect(screen,28,28,424,132,white);
		
		drawFillRect(screen,176,46,260,16,white);
		drawRect(screen,176,46,260,16,darkgrey);

		
		drawText(font,screen,40, 50, "Go to Line:",sdlblack);
		if (gotoline.size() > nMaxinput) {
			gotolinescroll = gotoline.substr(gotoline.size()-nMaxinput);
			if (blink < 15) drawVline(screen,176+32*8, 48,nLine, blue);
		}
		else {
			gotolinescroll = gotoline;
			if (blink < 15) drawVline(screen,180+gotoline.size()*nCol, 48, nLine, blue);
		}
		drawText(font,screen,180,50, gotolinescroll, sdlblack);
		drawText(font,screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,screen,40,140, "Press Enter to jump to line", sdlblue);
		drawText(font,screen,222,17,"Go To", sdlblack);
	}
	
	if (mode == 11) {
		blit(screen,0,0, img_background);
		drawMenuFrame(screen);
		
		if (colcursor == 1) drawTextShadowed(font,screen,40, 50, "Red:", sdlred);
		else drawText(font,screen,40, 50, "Red:" ,sdlblack);
		if (colcursor == 2) drawTextShadowed(font,screen,40, 70, "Green:", sdlgreen);
		else drawText(font,screen,40, 70, "Green:" ,sdlblack);
		if (colcursor == 3) drawTextShadowed(font,screen,40, 90, "Blue:", sdlblue);
		else drawText(font,screen,40, 90, "Blue:" ,sdlblack);
		sprintf(sizestring,"%d",bgcol.r);
		drawText(font,screen,365, 50, sizestring ,sdlblack);
		sprintf(sizestring,"%d",bgcol.g);
		drawText(font,screen,365, 70, sizestring ,sdlblack);
		sprintf(sizestring,"%d",bgcol.b);
		drawText(font,screen,365, 90, sizestring ,sdlblack);
		
		drawFillRect(screen,100,55,255,2,grey);
		drawFillRect(screen,100,75,255,2,grey);
		drawFillRect(screen,100,95,255,2,grey);
		
		drawFillRect(screen,99+bgcol.r,53,3,5,darkgrey);
		drawFillRect(screen,99+bgcol.g,73,3,5,darkgrey);
		drawFillRect(screen,99+bgcol.b,93,3,5,darkgrey);
		
		drawFillRect(screen,400,50,30,20,SDL_MapRGB(screen->format,bgcol.r,bgcol.g,bgcol.b));
		drawRect(screen,400,50,30,20,black);

		drawText(font,screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,screen,40,140, "Press Circle to select color", sdlblue);
		drawText(font,screen,184,17,"Background Color", sdlblack);
	}
	
	if (mode == 12) {
		blit(screen,0,0, img_background);
		drawMenuFrame(screen);
		
		if (colcursor == 1) drawTextShadowed(font,screen,40, 50, "Red:", sdlred);
		else drawText(font,screen,40, 50, "Red:" ,sdlblack);
		if (colcursor == 2) drawTextShadowed(font,screen,40, 70, "Green:", sdlgreen);
		else drawText(font,screen,40, 70, "Green:" ,sdlblack);
		if (colcursor == 3) drawTextShadowed(font,screen,40, 90, "Blue:", sdlblue);
		else drawText(font,screen,40, 90, "Blue:" ,sdlblack);
		sprintf(sizestring,"%d",fgcol.r);
		drawText(font,screen,365, 50, sizestring ,sdlblack);
		sprintf(sizestring,"%d",fgcol.g);
		drawText(font,screen,365, 70, sizestring ,sdlblack);
		sprintf(sizestring,"%d",fgcol.b);
		drawText(font,screen,365, 90, sizestring ,sdlblack);
		
		drawFillRect(screen,100,55,255,2,grey);
		drawFillRect(screen,100,75,255,2,grey);
		drawFillRect(screen,100,95,255,2,grey);
		
		drawFillRect(screen,99+fgcol.r,53,3,5,darkgrey);
		drawFillRect(screen,99+fgcol.g,73,3,5,darkgrey);
		drawFillRect(screen,99+fgcol.b,93,3,5,darkgrey);
		
		drawFillRect(screen,400,50,30,20,SDL_MapRGB(screen->format,fgcol.r,fgcol.g,fgcol.b));
		drawRect(screen,400,50,30,20,black);
		
		drawText(font,screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,screen,40,140, "Press Circle to select color", sdlblue);
		drawText(font,screen,205,17,"Text Color", sdlblack);
	}
	
	if (mode == 13) {
		blit(screen,0,0, img_background);

		drawKeyboard();
		drawMenuFrame(screen);
	
		//drawFillRect(screen,28,28,424,132,white);
		
		drawFillRect(screen,176,46,260,16,white);
		drawRect(screen,176,46,260,16,darkgrey);
		drawFillRect(screen,176,66,260,16,grey);
		drawRect(screen,176,66,260,16,darkgrey);
		
		drawText(font,screen,40, 50, "New Name:",sdlblack);
		drawText(font,screen,40, 70, "Old Name:",sdlblack);
		if (renamefile.size() > nMaxinput) {
			renamefilescroll = renamefile.substr(renamefile.size()-nMaxinput);
			if (blink < 15) drawVline(screen,178+32*8, 48,nLine, blue);
		}
		else {
			renamefilescroll = renamefile;
			if (blink < 15) drawVline(screen,181+openfile.size()*nCol, 48, nLine, blue);
		}
		drawText(font,screen,180,50, renamefilescroll.c_str(), sdlblack);
		if (oldfile.size() > nMaxinput) oldfilescroll = oldfile.substr(0,nMaxinput);
		else oldfilescroll = oldfile;
		drawText(font,screen,180,70, oldfilescroll.c_str(), sdlblack);

		//drawText(font,screen,40,100, "Press Start to change folder or select a file name", sdlblue);
		drawText(font,screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,screen,40,140, "Press Enter to rename", sdlblue);

		drawText(font,screen,211,17,"Rename File", sdlblack);
	}

	if (menumode > 0) {
		drawFillRect(screen,0,0,480,10, grey);
		drawHline(screen,0,0,480, lightgrey);
		drawHline(screen,0,10,480,darkgrey);
		if (menumode == 1) {
			drawFillRect(screen,8,0,32,10,darkgrey);
		}
		if (menumode == 2) {
			drawFillRect(screen,58,0,32,10,darkgrey);
		}
		if (menumode == 3) {
			drawFillRect(screen,108,0,32,10,darkgrey);
		}
		drawText(font,screen,11,0, "File", sdlblack);
		drawText(font,screen,61,0, "Edit", sdlblack);
		drawText(font,screen,111,0, "View", sdlblack);
	}	
	
	if (menumode == 1) {
		menupos = 10;
		drawText(font,screen,menupos,0, "File", sdlwhite);

		drawDropmenu(screen, menupos, 11, 6, 5);
		
		drawFillRect(screen,menupos+6,menucursor*nLine+4, 4*nCol+nCol*6-8, nLine, blue);

		if (menucursor == 1) drawTextShadowed(font,screen,menupos+20,nLine+4, "New", sdlwhite);
		else drawText(font,screen,menupos+20,nLine+4, "New", sdlblack);
		
		if (menucursor == 2) drawTextShadowed(font,screen,menupos+20,2*nLine+4, "Open", sdlwhite);
		else drawText(font,screen,menupos+20,2*nLine+4, "Open", sdlblack);
		
		if (menucursor == 3) drawTextShadowed(font,screen,menupos+20,3*nLine+4, "Save", sdlwhite);
		else drawText(font,screen,menupos+20,3*nLine+4, "Save", sdlblack);
		
		if (menucursor == 4) {
			drawTextShadowed(font,screen,menupos+20,4*nLine+4, "USB", sdlwhite);
			if (usb) blit(screen,menupos+4,4*nLine+6,img_check);
		}
		else {
			drawText(font,screen,menupos+20,4*nLine+4, "USB", sdlblack);
			if (usb) blit(screen,menupos+4,4*nLine+6,img_check);
		}
		if (menucursor == 5) drawTextShadowed(font,screen,menupos+20,5*nLine+4, "Exit", sdlwhite);
		else drawText(font,screen,menupos+20,5*nLine+4, "Exit", sdlblack);
		
	}
	
	if (menumode == 2) {
		menupos = 60;
		drawText(font,screen,menupos,0, "Edit", sdlwhite);

		drawDropmenu(screen, menupos, 11, 15, 9);
		
		drawFillRect(screen,menupos+6,menucursor*nLine+4, 4*nCol+nCol*15-8, nLine, blue);		
		
		if (menucursor == 1) drawTextShadowed(font,screen,menupos+20, nLine+4, "Cut", sdlwhite);
		else drawText(font,screen,menupos+20, nLine+4, "Cut", sdlblack);
		
		if (menucursor == 2) drawTextShadowed(font,screen,menupos+20,2*nLine+4, "Copy", sdlwhite);
		else drawText(font,screen,menupos+20,2*nLine+4, "Copy", sdlblack);
		
		if (menucursor == 3) drawTextShadowed(font,screen,menupos+20,3*nLine+4, "Paste", sdlwhite);
		else drawText(font,screen,menupos+20,3*nLine+4, "Paste", sdlblack);
		
		if (menucursor == 4) drawTextShadowed(font,screen,menupos+20,4*nLine+4, "Clear", sdlwhite);
		else drawText(font,screen,menupos+20,4*nLine+4, "Clear", sdlblack);
		
		if (menucursor == 5) drawTextShadowed(font,screen,menupos+20,5*nLine+4, "Find", sdlwhite);
		else drawText(font,screen,menupos+20,5*nLine+4, "Find", sdlblack);
		
		if (menucursor == 6) drawTextShadowed(font,screen,menupos+20,6*nLine+4, "Replace", sdlwhite);
		else drawText(font,screen,menupos+20,6*nLine+4, "Replace", sdlblack);
		
		if (menucursor == 7) drawTextShadowed(font,screen,menupos+20,7*nLine+4, "Goto", sdlwhite);
		else drawText(font,screen,menupos+20,7*nLine+4, "Goto", sdlblack);
		
		if (menucursor == 8) drawTextShadowed(font,screen,menupos+20,8*nLine+4, "Toggle Bookmark", sdlwhite);
		else drawText(font,screen,menupos+20,8*nLine+4, "Toggle Bookmark", sdlblack);
		
		if (menucursor == 9) drawTextShadowed(font,screen,menupos+20,9*nLine+4, "Goto Bookmark", sdlwhite);
		else drawText(font,screen,menupos+20,9*nLine+4, "Goto Bookmark", sdlblack);
	}
			
	if (menumode == 3) {
		menupos = 110;
		drawText(font,screen,menupos,0, "View", sdlwhite);

		drawDropmenu(screen, menupos, 11, 16, 8);
		
		drawFillRect(screen,menupos+6,menucursor*nLine+4, 4*nCol+nCol*16-8, nLine, blue);		
		
		if (menucursor == 1) drawTextShadowed(font,screen,menupos+20, nLine+4, "Full Screen", sdlwhite);
		else drawText(font,screen,menupos+20, nLine+4, "Full Screen", sdlblack);
		
		if (menucursor == 2) {
			drawTextShadowed(font,screen,menupos+20,2*nLine+4, "Keyboard 1", sdlwhite);
			if (nKeyset == 1) blit(screen,menupos+4,2*nLine+6,img_check);
		}
		else {
			drawText(font,screen,menupos+20,2*nLine+4, "Keyboard 1", sdlblack);
			if (nKeyset == 1) blit(screen,menupos+4,2*nLine+6,img_check);
		}
		if (menucursor == 3) {
			drawTextShadowed(font,screen,menupos+20,3*nLine+4, "Word Wrap 1", sdlwhite);
			if (wordwrap1) blit(screen,menupos+4,3*nLine+6,img_check);
		}
		else {
			drawText(font,screen,menupos+20,3*nLine+4, "Word Wrap 1", sdlblack);
			if (wordwrap1) blit(screen,menupos+4,3*nLine+6,img_check);
		}
		if (menucursor == 4) {
			drawTextShadowed(font,screen,menupos+20,4*nLine+4, "Word Wrap 2", sdlwhite);
			if (wordwrap2) blit(screen,menupos+4,4*nLine+6,img_check);
		}
		else {
			drawText(font,screen,menupos+20,4*nLine+4, "Word Wrap 2", sdlblack);
			if (wordwrap2) blit(screen,menupos+4,4*nLine+6,img_check);
		}
		if (menucursor == 5) {
			if (nFontsize > 10) drawTextShadowed(font,screen,menupos+20,5*nLine+4, "Font Size -", sdlwhite);
			else drawText(font,screen,menupos+20,5*nLine+4, "Font Size -", sdlgrey);
		}
		else {
			if (nFontsize > 10) drawText(font,screen,menupos+20,5*nLine+4, "Font Size -", sdlblack);
			else drawText(font,screen,menupos+20,5*nLine+4, "Font Size -", sdlgrey);
		}
		if (menucursor == 6) {
			if (nFontsize < 16) drawTextShadowed(font,screen,menupos+20,6*nLine+4, "Font Size +", sdlwhite);
			else drawText(font,screen,menupos+20,6*nLine+4, "Font Size +", sdlgrey);
		}
		else {
			if (nFontsize < 16) drawText(font,screen,menupos+20,6*nLine+4, "Font Size +", sdlblack);
			else drawText(font,screen,menupos+20,6*nLine+4, "Font Size +", sdlgrey);
		}
		if (menucursor == 7) drawTextShadowed(font,screen, menupos+20,7*nLine+4, "Background Color", sdlwhite);
		else drawText(font,screen,menupos+20,7*nLine+4,"Background Color", sdlblack);
		if (menucursor == 8) drawTextShadowed(font,screen, menupos+20,8*nLine+4, "Text Color", sdlwhite);
		else drawText(font,screen,menupos+20,8*nLine+4,"Text Color", sdlblack);			
		
	}	

		if (latch.uiRelease == -1) padrelease = true;
		SDL_Delay(wait);
		SDL_Flip(screen);

		bUpdate = false;
	}
	SDL_FreeSurface(img_text);
	/*
	TTF_CloseFont(systemfont);
	TTF_CloseFont(font);
	TTF_CloseFont(drawfont);
	TTF_CloseFont(drawfont10);
	TTF_CloseFont(drawfont12);
	TTF_CloseFont(drawfont14);
	TTF_CloseFont(drawfont16);
	*/
    //Exit program
    sceKernelExitGame();
	return 0;
}


string readKey(void) {
	if (nKeyset == 1) {
		if (pad.Buttons & PSP_CTRL_CIRCLE) {
			if (keys[ly][lx] == "ls" || keys[ly][lx] == "cl" || keys[ly][lx] == "rs") return "";
			if (!shift && !caps) return keys[ly][lx];
			if (shift && !caps) return skeys[ly][lx];
			if (caps && !shift) return ckeys[ly][lx];
			if (caps && shift) return cskeys[ly][lx];
		}
	}
	if (nKeyset == 2) {
		if (pad.Buttons & PSP_CTRL_LTRIGGER) {
			if (lkeys[ly][lx] == "ls" || lkeys[ly][lx] == "cl") return "";
			if (!shift && !caps) return lkeys[ly][lx];
			if (shift && !caps) return lskeys[ly][lx];
			if (caps && !shift) return lckeys[ly][lx];
			if (caps && shift) return lcskeys[ly][lx];
		}
		if (pad.Buttons & PSP_CTRL_RTRIGGER) {
			if (rkeys[ry][rx] == "rs") return "";
			if (!shift && !caps) return rkeys[ry][rx];
			if (shift && !caps) return rskeys[ry][rx];
			if (caps && !shift) return rckeys[ry][rx];
			if (caps && shift) return rcskeys[ry][rx];
		}
	}
	return "";
}

void readKeyboard(void) {
	if (nKeyset == 1) {
		if (pad.Buttons & PSP_CTRL_UP) {
			ly = ly - 1;
			if (ly < 0) ly = 0;
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_DOWN) {
			ly = ly + 1;
			if (ly > 3) ly = 3;
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_LEFT) {
			lx = lx - 1;
			if (lx < 0) lx = 0;
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			lx = lx + 1;
			if (lx > 16) lx = 16;
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_CIRCLE) {
			if (keys[ly][lx] == "cl") {
				caps = !caps;
				wait = 100;
			}
			if (keys[ly][lx] == "ls") {
				shift = !shift;
				wait = 60;
			}
			if (keys[ly][lx] == "rs") {
				shift = !shift;
				wait = 60;
			}
		}
	}
	if (nKeyset == 2) {
		if (pad.Buttons & PSP_CTRL_UP) {
			ly = ly - 1;
			if (ly < 0) ly = 0;
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_DOWN) {
			ly = ly + 1;
			if (ly > 3) ly = 3;
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_LEFT) {
			lx = lx - 1;
			if (lx < 0) lx = 0;
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			lx = lx + 1;
			if (lx > 8) lx = 8;
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_TRIANGLE) {
			ry = ry - 1;
			if (ry < 0) ry = 0;
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_CROSS) {
			ry = ry + 1;
			if (ry > 3) ry = 3;
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_SQUARE) {
			rx = rx - 1;
			if (rx < 0) rx = 0;
			wait = 80;
		}
		if (pad.Buttons & PSP_CTRL_CIRCLE) {
			rx = rx + 1;
			if (rx > 8) rx = 8;
			wait = 80;
		}
		
		if (pad.Buttons & PSP_CTRL_RTRIGGER)
			if (rkeys[ry][rx] == "rs") {
			shift = !shift;
			wait = 60;
			}
		
		if (pad.Buttons & PSP_CTRL_LTRIGGER) {
			if (lkeys[ly][lx] == "cl") {
				caps = !caps;
				wait = 100;
			}
			if (lkeys[ly][lx] == "ls") {
				shift = !shift;
				wait = 60;
			}
		}
	}
}

void textWrap1(void) {
	int lenw, fl, count;
	string temp, trunctext;
	
	wraptext.clear();
	wraptext = text;
	nWW = wraptext.size();
	count = 0;
	while (count < wraptext.size()) {
		lenw = wraptext[count].size();
		if (lenw > nMaxchar) {
			
			fl = wraptext[count].find_last_of(" ", nMaxchar);
			
			if (fl == string::npos) {
				trunctext = wraptext[count].substr(nMaxchar+1);
				wraptext[count] = wraptext[count].substr(0,nMaxchar);
			}
			else {
				trunctext = wraptext[count].substr(fl+1);
				wraptext[count] = wraptext[count].substr(0, fl);
			}
			wraptext.insert(wraptext.begin()+count+1, trunctext);											
		}
		count++;
	}
	nWW = wraptext.size();
}

void textWrap2(void) {
	int lenw, fl, count;
	string temp, trunctext;
	
	wraptext.clear();
	wraptext = text;
	nWW = wraptext.size();
	count = 0;
	while (count < wraptext.size()) {
		lenw = wraptext[count].size();
		if (lenw > nMaxchar) {
			if (count == wraptext.size()-1) wraptext.push_back("");
			fl = wraptext[count].find_last_of(" ", nMaxchar);
			if (fl == string::npos) {
				trunctext = wraptext[count].substr(nMaxchar+1);
				if (wraptext[count+1].substr(0,1) == " ") wraptext.insert(wraptext.begin()+count+1, trunctext);
				else if (wraptext[count+1].size() > 0) wraptext[count+1] = trunctext + " " + wraptext[count+1];
				else {
					wraptext[count+1] = trunctext;
					wraptext.insert(wraptext.begin()+count+2, "");
				}													
				wraptext[count] = wraptext[count].substr(0,nMaxchar);
			}
			else {
				trunctext = wraptext[count].substr(fl+1);
				if (wraptext[count+1].substr(0,1) == " ") wraptext.insert(wraptext.begin()+count+1, trunctext);			
				else if (wraptext[count+1].size() > 0) wraptext[count+1] = trunctext + " " + wraptext[count+1];
				else {
					wraptext[count+1] = trunctext;
					wraptext.insert(wraptext.begin()+count+2, "");
				}		
				wraptext[count] = wraptext[count].substr(0, fl);
			}										
		}
		count++;
	}
	nWW = wraptext.size();
}

bool is_image(string file) {
	string extension;
	int findlast;
	
	findlast = file.find_last_of(".");
	
	if (findlast != string::npos) extension = file.substr(findlast+1,3);
	if (extension == "BMP" || extension == "bmp" || extension == "GIF" || extension == "gif" || 
		extension == "JPG" || extension == "jpg" || extension == "PNG" || extension == "png")
		return true;
	else return false;
}
	

void listDirectory(string path) {
	int count;
	Dir tmpdir;
	vector <string> dirdir;
	vector <string> dirfile;
	
	int fd = sceIoDopen(path.c_str());
	dir.clear();
	dirlist.clear();
	while (sceIoDread(fd, &g_dir) > 0) {
		tmpdir.name = g_dir.d_name;
		//tmpdir.size = g_dir.d_stat.st_size;
		tmpdir.isDir = g_dir.d_stat.st_attr & FIO_SO_IFDIR;
		//dir.push_back(tmpdir);
		
		if (tmpdir.isDir) dirdir.push_back(tmpdir.name);
		else {
			dirfile.push_back(tmpdir.name);
			if (is_image(tmpdir.name)) dirlist.push_back(tmpdir.name);
		}
	}
	
	sort(dirdir.begin(), dirdir.end());
	sort(dirfile.begin(), dirfile.end());
	sort(dirlist.begin(), dirlist.end());
	
	for (count = 0; count < dirdir.size(); count++) {
		tmpdir.name = dirdir.at(count);
		tmpdir.isDir = 1;
		dir.push_back(tmpdir);
	}
	
	for (count = 0; count < dirfile.size(); count++) {
		tmpdir.name = dirfile.at(count);
		tmpdir.isDir = 0;
		dir.push_back(tmpdir);
	}	
}


void update(void) {
	bUpdate = true;
	SDL_FillRect(img_textbackground,NULL, backcol);
}

void drawFillRect(SDL_Surface* surface, int x0,int y0, int w, int h, Uint32 color) {
	SDL_Rect rect;
	
	rect.x = x0;
	rect.y = y0;
	rect.w = w;
	rect.h = h;
	SDL_FillRect(surface, &rect, color);
}

void drawHline(SDL_Surface* surface, int x0, int y0, int w, Uint32 color) {
	SDL_Rect rect;
	
	rect.x = x0;
	rect.y = y0;
	rect.w = w;
	rect.h = 1;
	SDL_FillRect(surface, &rect, color);
}

void drawVline(SDL_Surface* surface, int x0, int y0, int h, Uint32 color) {
	SDL_Rect rect;
	
	rect.x = x0;
	rect.y = y0;
	rect.w = 1;
	rect.h = h;
	SDL_FillRect(surface, &rect, color);
}

void drawDropmenu(SDL_Surface* surface, int x0, int y0, int nChar, int nList) {
	drawFillRect(screen,x0,y0,nChar*nCol+nCol*4,nList*nLine+nLine/2,white);
	drawRect(screen,x0,y0,nChar*nCol+nCol*4,nList*nLine+nLine/2,darkgrey);
	drawRect(screen,x0+1,y0+1,nChar*nCol+nCol*4,nList*nLine+nLine/2,black);
	drawRect(screen,x0+2,y0+2,nChar*nCol+nCol*4,nList*nLine+nLine/2,darkgrey);
	drawRect(screen,x0+3,y0+3,nChar*nCol+nCol*4,nList*nLine+nLine/2,grey);
	drawRect(screen,x0+4,y0+4,nChar*nCol+nCol*4,nList*nLine+nLine/2,lightgrey);
}

void drawFrame(SDL_Surface* surface, int x0, int y0, int w, int h) {
	SDL_Rect rect;
	
	rect.x = x0;
	rect.y = y0;
	rect.w = w-2;
	rect.h = 8;
	SDL_FillRect(surface,&rect, grey); // top bar
	//screen:fillRect(0,0,478,8,grey) -- top bar
	rect.x = x0+3;
	rect.y = y0+7;
	rect.w = w-6;
	rect.h = 1;
	SDL_FillRect(surface,&rect,darkgrey); // top line
	//screen:drawLine(3,7,474,7,darkgrey) -- top line
	rect.x = x0;
	rect.y = y0;
	rect.w = 4;
	rect.h = h-1;
	SDL_FillRect(surface,&rect,grey); // left bar
	//screen:fillRect(0,0,4,186,grey) -- left bar
	rect.x = x0+3;
	rect.y = y0+8;
	rect.w = 1;
	rect.h = h-6-8;
	SDL_FillRect(surface,&rect,darkgrey); // left line
	//screen:drawLine(3,8,3,180,darkgrey) -- left line
	rect.x = x0+w-4;
	rect.y = y0;
	rect.w = 4;
	rect.h = h-1;
	SDL_FillRect(surface,&rect,grey); // right bar
	//screen:fillRect(476,0,4,186,grey) -- right bar
	rect.x = x0+w-2;
	rect.y = y0+2;
	rect.w = 2;
	rect.h = h-2;
	SDL_FillRect(surface,&rect,darkgrey); // right line
	//screen:fillRect(478,2,2,186,darkgrey) -- right line	
	rect.x = x0;
	rect.y = y0+h-8;
	rect.w = w-2;
	rect.h = 6;
	SDL_FillRect(surface,&rect,grey); // bottom bar
	//screen:fillRect(0,180,478,7,grey) -- bottom bar
	rect.x = x0+2;
	rect.y = y0+h-2;
	rect.w = w-2;
	rect.h = 2;
	SDL_FillRect(surface,&rect,darkgrey); // bottom line
	//screen:fillRect(2,187,480,2,darkgrey) -- bottom line
	rect.x = x0+3;
	rect.y = y0+h-8;
	rect.w = w-4-3;
	rect.h = 1;
	SDL_FillRect(surface,&rect,lightgrey);
	//screen:drawLine(3,180,476,180,lightgrey)
}

void drawKeyboard(void) {
	if (!shift and !caps and !shift) {
		sge_Blit(img_lkeys, screen, 0,0,70,190,img_lkeys->w, img_lkeys->h);
		sge_Blit(img_rkeys, screen, 0,0,250,190,img_rkeys->w, img_rkeys->h);
	}
	if ((shift or shift) and !caps) {
		sge_Blit(img_lskeys, screen, 0,0,70,190,img_lskeys->w, img_lskeys->h);
		sge_Blit(img_rskeys, screen, 0,0,250,190,img_rskeys->w, img_rskeys->h);
	}
	if (caps and !shift and !shift) {	
		sge_Blit(img_lckeys, screen, 0,0,70,190,img_lckeys->w, img_lckeys->h);
		sge_Blit(img_rckeys, screen, 0,0,250,190,img_rckeys->w, img_rckeys->h);
	}
	if ((shift or shift) and caps) {
		sge_Blit(img_lcskeys, screen, 0,0,70,190,img_lcskeys->w, img_lcskeys->h);
		sge_Blit(img_rcskeys, screen, 0,0,250,190,img_rcskeys->w, img_rcskeys->h);
	}
	sge_Blit(img_space, screen, 0,0, 230, 190, img_space->w, img_space->h);
	drawRect(screen, 70 + (lx) * 20, 190 + (ly) * 20, 20, 20, green);
	if (nKeyset == 2) drawRect(screen, 230 + (rx) * 20, 190 + (ry) * 20, 20, 20, red);
}

void drawMenuFrame(SDL_Surface* surface) {
	SDL_Rect rect;
	rect.x = 25;
	rect.y = 25;
	rect.w = 440;
	rect.h = 148;
	SDL_FillRect(surface,&rect,black); // drop shadow
	//screen:fillRect(25,25,440,148,black) -- drop shadow
	rect.x = 28;
	rect.y = 28;
	rect.w = 424;
	rect.h = 132;
	SDL_FillRect(surface,&rect,white);
	rect.x = 20;
	rect.y = 17;
	rect.w = 440;
	rect.h = 10;
	SDL_FillRect(surface,&rect,grey); // top bar
	//screen:fillRect(20,17,440,10,grey) --top bar
	rect.x = 20;
	rect.y = 17;
	rect.w = 460-20;
	rect.h = 1;
	SDL_FillRect(surface,&rect,lightgrey); // very top line
	//screen:drawLine(20,17,460,17,lightgrey) -- very top line
	rect.x = 28;
	rect.y = 27;
	rect.w = 450-26;
	rect.h = 1;
	SDL_FillRect(surface,&rect,darkgrey); // top line
	//screen:drawLine(28,27,450,27,darkgrey)  --top line
	rect.x = 20;
	rect.y = 20;
	rect.w = 8;
	rect.h = 146;
	SDL_FillRect(surface,&rect,grey); // line	bar
	//screen:fillRect(20,20,8,146,grey) --left bar
	rect.x = 452;
	rect.y = 20;
	rect.w = 8;
	rect.h = 147;
	SDL_FillRect(surface,&rect,grey); // right bar
	//screen:fillRect(452,20,8,147,grey) --right bar
	rect.x = 20;
	rect.y = 160;
	rect.w = 440;
	rect.h = 8;
	SDL_FillRect(surface,&rect,grey); // bottom bar
	//screen:fillRect(20,160,440,8,grey) --bottom bar
	rect.x = 27;
	rect.y = 28;
	rect.w = 1;
	rect.h = 160-28;
	SDL_FillRect(surface,&rect,darkgrey); // left line	
	//screen:drawLine(27,28,27,160,darkgrey) --left line
	drawFillRect(screen,28,28,424,132,white);
}

void drawRect(SDL_Surface* surface, int x0, int y0, int w, int h, Uint32 color) {
	SDL_Rect rect;
	rect.x = x0;
	rect.y = y0;
	rect.w = w;
	rect.h = 1;
	SDL_FillRect(surface,&rect,color);
	rect.x = x0;
	rect.y = y0;
	rect.w = 1;
	rect.h = h;
	SDL_FillRect(surface,&rect,color);
	rect.x = x0+w - 1;
	rect.y = y0;
	rect.w = 1;
	rect.h = h;
	SDL_FillRect(surface,&rect,color);
	rect.x = x0;
	rect.y = y0+h - 1;
	rect.w = w;
	rect.h = 1;
	SDL_FillRect(surface,&rect,color); 
}

void loadSettings(void) {
	SDL_Color bgcol;
	string readline;
	Sint32 loc;
	ifstream file("settings.ini");
	
	settings.clear();
	while (getline(file,readline,'\n')) {
		
		loc = readline.find((char) 13,0);
		if (loc != string::npos) readline.resize(readline.size()-1);
		loc = readline.find((char) 9,0);
		while (loc != string::npos) {
			readline.replace(loc,1,"     ",5);
			loc = readline.find((char) 9,0);
		}
		settings.push_back(readline);
	}
	file.close();

	nKeyset = atoi(settings[1].c_str());

	nFontsize = atoi(settings[2].c_str());
	setBounds(nFontsize);

	bgcol.r = atoi(settings[3].c_str());
	bgcol.g = atoi(settings[4].c_str());
	bgcol.b = atoi(settings[5].c_str());
	backcol = SDL_MapRGB(screen->format,bgcol.r,bgcol.g,bgcol.b);
	forecol.r = atoi(settings[6].c_str());
	forecol.g = atoi(settings[7].c_str());
	forecol.b = atoi(settings[8].c_str());

	update();
}

void setBounds(int fontsize) {
	if (fontsize == 10) {
		nMaxchar = 79;
		ndCol = 6;
		ndLine = 10;
		minlines = 17;
		maxlines = 25;
		drawfont = drawfont10;
	}
	if (fontsize == 12) {
		nMaxchar = 67;
		ndCol = 7;
		ndLine = 12;
		minlines = 14;
		maxlines = 21;
		drawfont = drawfont12;
	}
	if (fontsize == 14) {
		nMaxchar = 59;
		ndCol = 8;
		ndLine = 14;
		minlines = 12;
		maxlines = 18;
		drawfont = drawfont14;
	}
	if (fontsize == 16) {
		nMaxchar = 47;
		ndCol = 10;
		ndLine = 16;
		minlines = 10;
		maxlines = 16;
		drawfont = drawfont16;
	}
}

void saveSettings(void) {
	ofstream writefile;
	SDL_Color bgcol;
	char input[3];
	int count;
	
	SDL_GetRGB(backcol, screen->format,&bgcol.r, &bgcol.g, &bgcol.b);
	sprintf(input,"%d",nKeyset);
	settings[1] = input;
	sprintf(input,"%d",nFontsize);
	settings[2] = input;
	sprintf(input,"%d",bgcol.r);
	settings[3] = input;
	sprintf(input,"%d",bgcol.g);
	settings[4] = input;
	sprintf(input,"%d",bgcol.b);
	settings[5] = input;
	sprintf(input,"%d",forecol.r);
	settings[6] = input;
	sprintf(input,"%d",forecol.g);
	settings[7] = input;
	sprintf(input,"%d",forecol.b);
	settings[8] = input;
	writefile.open("settings.ini");
	for (count = 0; count < settings.size(); count++) {		
		writefile << settings[count] << endl;
	}
	writefile.close();
}

void set_colors(SDL_PixelFormat* format)
{
	backcol = SDL_MapRGB(format,255,255,255);
	red = SDL_MapRGB(format,255,0,0);
	green = SDL_MapRGB(format,0,255,0);
	blue = SDL_MapRGB(format,0,0,255);
	white = SDL_MapRGB(format,255,255,255);
	black = SDL_MapRGB(format,0,0,0);
	lightgrey = SDL_MapRGB(format,224,224,224);
	grey = SDL_MapRGB(format,200,200,200);
	darkgrey = SDL_MapRGB(format,125,125,125);
}

int load_gfx(void)
{
	SDL_Surface *tmp;

	tmp=IMG_Load("image/metal.png");
	if(!tmp){SDL_SetError("Couldn't load image/metal.png"); return -1;}
	img_background=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	tmp=IMG_Load("image/arrows.png");
	if(!tmp){SDL_SetError("Couldn't load image/arrows.png"); return -1;}
	img_arrows=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	tmp=IMG_Load("image/ascii.png");
	if(!tmp){SDL_SetError("Couldn't load image/ascii.png"); return -1;}
	img_ascii=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	tmp=IMG_Load("image/buttons.png");
	if(!tmp){SDL_SetError("Couldn't load image/buttons.png"); return -1;}
	img_buttons=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/check.png");
	if(!tmp){SDL_SetError("Couldn't load image/check.png"); return -1;}
	img_check=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	

	tmp=IMG_Load("image/cleft.png");
	if(!tmp){SDL_SetError("Couldn't load image/cleft.png"); return -1;}
	img_lckeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/cright.png");
	if(!tmp){SDL_SetError("Couldn't load image/cright.png"); return -1;}
	img_rckeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/csleft.png");
	if(!tmp){SDL_SetError("Couldn't load image/csleft.png"); return -1;}
	img_lcskeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/csright.png");
	if(!tmp){SDL_SetError("Couldn't load image/csright.png"); return -1;}
	img_rcskeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/doc.png");
	if(!tmp){SDL_SetError("Couldn't load image/doc.png"); return -1;}
	img_doc=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/dot.png");
	if(!tmp){SDL_SetError("Couldn't load image/dot.png"); return -1;}
	img_dot=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/folder.png");
	if(!tmp){SDL_SetError("Couldn't load image/folder.png"); return -1;}
	img_folder=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/left.png");
	if(!tmp){SDL_SetError("Couldn't load image/left.png"); return -1;}
	img_lkeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/right.png");
	if(!tmp){SDL_SetError("Couldn't load image/right.png"); return -1;}
	img_rkeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/sleft.png");
	if(!tmp){SDL_SetError("Couldn't load image/sleft.png"); return -1;}
	img_lskeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/space.png");
	if(!tmp){SDL_SetError("Couldn't load image/space.png"); return -1;}
	img_space=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/sright.png");
	if(!tmp){SDL_SetError("Couldn't load image/sright.png"); return -1;}
	img_rskeys=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);	
	
	tmp=IMG_Load("image/textbackground.png");
	if(!tmp){SDL_SetError("Couldn't load image/textbackground.png"); return -1;}
	img_textbackground=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	
	return 0;
}


void drawText(TTF_Font* font,SDL_Surface* surface, int x, int y, string text, SDL_Color color) {
	SDL_Surface *tmp_text;
	if (text.size() < 1) text = " ";
	tmp_text = TTF_RenderText_Blended(font, text.c_str(), color);
	sge_Blit(tmp_text, surface, 0, 0, x, y, tmp_text->w, tmp_text->h);
	SDL_FreeSurface(tmp_text);
}

void drawTextShadowed(TTF_Font* font,SDL_Surface* surface, int x, int y, string text, SDL_Color color) {
	SDL_Surface *tmp_text;
	if (text.size() < 1) text = " ";
	tmp_text = TTF_RenderText_Blended(font, text.c_str(), sdlblack);
	sge_Blit(tmp_text, surface, 0, 0, x+1, y+1, tmp_text->w, tmp_text->h);
	tmp_text = TTF_RenderText_Blended(font, text.c_str(), color);
	sge_Blit(tmp_text, surface, 0, 0, x, y, tmp_text->w, tmp_text->h);
	SDL_FreeSurface(tmp_text);
}

//==================================================================================
// Clear surface to color
//==================================================================================
void sge_ClearSurface(SDL_Surface *Surface, Uint32 color)
{

	SDL_FillRect(Surface,NULL, color);

	if(_sge_update!=1){return;}
	SDL_UpdateRect(Surface, 0,0,0,0);
}

void blit(SDL_Surface * Dest, Sint16 DestX, Sint16 DestY, SDL_Surface * Src) {
	sge_Blit(Src,Dest, 0,0,DestX,DestY,Src->w,Src->h);
}
//==================================================================================
// Blit from one surface to another (not touching alpha or color key -
// use SDL_SetColorKey and SDL_SetAlpha)
//==================================================================================
int sge_Blit(SDL_Surface *Src, SDL_Surface *Dest, Sint16 SrcX, Sint16 SrcY, Sint16 DestX, Sint16 DestY, Sint16 W, Sint16 H)
{
	SDL_Rect src, dest;
	int ret;

	/* Dest clipping */
	#if SDL_VERSIONNUM(SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL) < \
    SDL_VERSIONNUM(1, 1, 5)
	int flag=0;		
	if (DestX < Dest->clip_minx){
		SrcX += Dest->clip_minx-DestX;
		W -= Dest->clip_minx-DestX -1;
		DestX=Dest->clip_minx;
 	}
	if (DestY < Dest->clip_miny){
		SrcY +=Dest->clip_miny-DestY;
		H -= Dest->clip_miny-DestY -1;
 		DestY=Dest->clip_miny;
 	}
	if ((DestX + W) > Dest->clip_maxx){
		W = W - ((DestX + W) - Dest->clip_maxx)+1;
		if(W<=0){SDL_SetError("SGE - Blit error");return -1;}
	}
 	if ((DestY + H) > Dest->clip_maxy){
		H = H - ((DestY + H) - Dest->clip_maxy)+1;
		if(H<=0){SDL_SetError("SGE - Blit error");return -1;}
 	}
	#endif

 	/* Initialize our rectangles */
 	src.x = SrcX;
 	src.y = SrcY;
 	src.w = W;
 	src.h = H;

 	dest.x = DestX;
 	dest.y = DestY;
 	dest.w = W;
 	dest.h = H;

	/* We don't care about src clipping, only dest! */
	#if SDL_VERSIONNUM(SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL) < \
    SDL_VERSIONNUM(1, 1, 5)
	if ( (Src->flags & SDL_SRCCLIPPING) == SDL_SRCCLIPPING){
		Src->flags &= ~SDL_SRCCLIPPING; flag=1;
	}
	#endif

	/* Blit */
 	ret=SDL_BlitSurface(Src, &src, Dest, &dest);

	/* Set the correct flag */
	#if SDL_VERSIONNUM(SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL) < \
    SDL_VERSIONNUM(1, 1, 5)
	if (flag==1){
		Src->flags |= SDL_SRCCLIPPING;
	}
	#endif

	return ret;
}

//helper function to make things easier
int LoadStartModule(char *path)
{
    u32 loadResult;
    u32 startResult;
    int status;

    loadResult = sceKernelLoadModule(path, 0, NULL);
    if (loadResult & 0x80000000)
	return -1;
    else
	startResult =
	    sceKernelStartModule(loadResult, 0, NULL, &status, NULL);

    if (loadResult != startResult)
	return -2;

    return 0;
}

void loadUsbDrivers(void) {
	u32 retVal;
	
    //start necessary drivers
    LoadStartModule("flash0:/kd/semawm.prx");
    LoadStartModule("flash0:/kd/usbstor.prx");
    LoadStartModule("flash0:/kd/usbstormgr.prx");
    LoadStartModule("flash0:/kd/usbstorms.prx");
    LoadStartModule("flash0:/kd/usbstorboot.prx");

    //setup USB drivers
    retVal = sceUsbStart(PSP_USBBUS_DRIVERNAME, 0, 0);
    if (retVal != 0) {
	printf("Error starting USB Bus driver (0x%08X)\n", retVal);
	sceKernelSleepThread();
    }
    retVal = sceUsbStart(PSP_USBSTOR_DRIVERNAME, 0, 0);
    if (retVal != 0) {
	printf("Error starting USB Mass Storage driver (0x%08X)\n",
	       retVal);
	sceKernelSleepThread();
    }
    retVal = sceUsbstorBootSetCapacity(0x800000);
    if (retVal != 0) {
	printf
	    ("Error setting capacity with USB Mass Storage driver (0x%08X)\n",
	     retVal);
	sceKernelSleepThread();
    }
    retVal = 0;
}
